#include "types.h"
#include "les_const.h"

SUBROUTINE SGS_ARM_Z(itype_loc, n0, delta_w, x, y, z, dx, dy, dz, &
     rho, z1, barvs, c0, rhoz_m, txc, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z)

! txc size is 4

  USE DNS_GLOBAL

  IMPLICIT NONE

#include "integers.h"

  TINTEGER itype_loc, n0
  TREAL delta_w
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TREAL x(imax)
  TREAL y(jmax)
  TREAL z(kmax_total)
  TREAL rho(imax,jmax,kmax)
  TREAL z1(imax,jmax,kmax)
  TREAL barvs(imax,jmax,kmax)
  TREAL c0(*)
  TREAL rhoz_m(imax,jmax,kmax)
  TREAL wrk1d(isize_wrk1d,*)
  TREAL wrk2d(*)
  TREAL wrk3d(imax,jmax,kmax)
  TREAL txc(imax,jmax,kmax,*)
  TREAL cf0x(*), cf0y(*), cf0z(*)

  TINTEGER ij, j, k
!  TREAL SIMPSON_NU, a0_int, a1_int, a2_int, c0_int

#define RHOZ2_SG(j)  wrk1d(j,1)
#define A0(j)        wrk1d(j,2)
#define A1(j)        wrk1d(j,3)
#define A2(j)        wrk1d(j,4)

! ARM inviscid
  IF ( itype_loc .EQ. 4 ) THEN !ARMINVS
     DO j = 1,jmax
        c0(j) = arm_c0_inviscid
     ENDDO

! ARM rans
  ELSE IF ( itype_loc .EQ. 2 ) THEN !ARMRANS
! ----------------------------------------------------------------
!                           calculating average <rho*(Z^2)_sg>
! ----------------------------------------------------------------
     CALL SGS_ARM_RANS_ZSG(imax, jmax, kmax, kmax_total,&
          area, rtime, delta_w, scaley, x, y, z, dx, dy, dz, &
          rho, z1, RHOZ2_SG(1), A0(1), wrk3d)

! ----------------------------------------------------------------
!                                               calculating c0
! ----------------------------------------------------------------
     DO k = 1,kmax
        DO ij = 1,NN
           rhoz_m(ij,1,k) = rho(ij,1,k)*z1(ij,1,k)
        ENDDO
     ENDDO
! txc size is 4
     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,&
          i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
          dx, dy, dz, rho, barvs, &
          rhoz_m, RHOZ2_SG(1), A0(1), A1(1), A2(1), &
          cf0x, cf0y, cf0z, txc, wrk3d)
     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), &
          A2(1), c0)
!     a0_int = SIMPSON_NU(jmax,A0(1),y)
!     a1_int = SIMPSON_NU(jmax,A1(1),y)
!     a2_int = SIMPSON_NU(jmax,A2(1),y)
!     CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!     DO j = 1,jmax
!        c0(j) = c0_int
!     ENDDO

  ENDIF

  arm_zcoef = MAXVAL(c0(1:jmax))

#undef RHOZ2_SG
#undef A0
#undef A1
#undef A2

! ----------------------------------------------------------------
!                                                  model field
! ----------------------------------------------------------------
! saving mu_m into txc
  DO k = 1,kmax
     DO ij = 1,NN
        txc(ij,1,k,1) = rhoz_m(ij,1,k)
     ENDDO
  ENDDO
  CALL SGS_ARM_UM(n0, dx, dy, dz, &
       cf0x, cf0y, cf0z, c0, txc, rhoz_m, wrk1d, wrk3d)

  RETURN
END SUBROUTINE SGS_ARM_Z
