#include "types.h"
#include "les_const.h"

SUBROUTINE SGS_ARM_P(n0, x, y, z, dx, dy, dz, &
     rho, p, barvs, c0, p_m, txc, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z)

! txc size is 4

  USE DNS_GLOBAL

  IMPLICIT NONE

#include "integers.h"

  TINTEGER n0
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TREAL x(imax)
  TREAL y(jmax)
  TREAL z(kmax_total)
  TREAL rho(imax,jmax,kmax)
  TREAL p(imax,jmax,kmax)
  TREAL barvs(imax,jmax,kmax)
  TREAL c0(*)
  TREAL p_m(imax,jmax,kmax)
  TREAL wrk1d(isize_wrk1d,*)
  TREAL wrk2d(*)
  TREAL wrk3d(imax,jmax,kmax)
  TREAL txc(imax,jmax,kmax,*)
  TREAL cf0x(*), cf0y(*), cf0z(*)

  TINTEGER ij, j, k
!  TREAL SIMPSON_NU, a0_int, a1_int, a2_int, c0_int
  TREAL AVG_IK

#define P2_SG(j)  wrk1d(j,1)
#define A0(j)     wrk1d(j,2)
#define A1(j)     wrk1d(j,3)
#define A2(j)     wrk1d(j,4)

! ARM inviscid
  IF ( iles_type_tran .EQ. LES_TRAN_ARMINVS ) THEN
     DO j = 1,jmax
        c0(j) = arm_c0_inviscid
     ENDDO

! ARM rans
  ELSE IF ( iles_type_tran .EQ. LES_TRAN_ARMRANS ) THEN
! ----------------------------------------------------------------
!                                   calculating average <p_sg>
! ----------------------------------------------------------------
! Use from A0 as wrk1d array
     CALL SGS_ARM_RANS_PSG(imax, jmax, kmax, kmax_total,&
          area, rtime, x, y, z, dx, dy, dz, &
          p, P2_SG(1), A0(1), wrk3d)

! ----------------------------------------------------------------
!                                               calculating c0
! ----------------------------------------------------------------
! txc size is 4
     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,&
          i0, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
          dx, dy, dz, rho, barvs, &
          p, P2_SG(1), A0(1), A1(1), A2(1), &
          cf0x, cf0y, cf0z, txc, wrk3d)
     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), &
          A2(1), c0)
!     a0_int = SIMPSON_NU(jmax,A0(1),y)
!     a1_int = SIMPSON_NU(jmax,A1(1),y)
!     a2_int = SIMPSON_NU(jmax,A2(1),y)
!     CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!     DO j = 1,jmax
!        c0(j) = c0_int
!     ENDDO
  ENDIF

  arm_pcoef = MAXVAL(c0(1:jmax))

#undef P2_SG
#undef A0
#undef A1
#undef A2

! ----------------------------------------------------------------
!                                                  model field
! ----------------------------------------------------------------
! txc size is 1
  CALL SGS_ARM_UM(n0, dx, dy, dz, &
       cf0x, cf0y, cf0z, c0, p, p_m, wrk1d, wrk3d)

#ifdef _DEBUG
  DO k = 1,kmax
     DO ij = 1,NN
        txc(ij,1,k,1) = p_m(ij,1,k)*p_m(ij,1,k)
     ENDDO
  ENDDO
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, txc(1,1,1,1), txc(1,1,1,2), &
       wrk3d)
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, p_m, txc(1,1,1,1), &
       wrk3d)
  DO k = 1,kmax
     DO ij = 1,NN
        txc(ij,1,k,2) = txc(ij,1,k,2)-&
             txc(ij,1,k,1)*txc(ij,1,k,1)
     ENDDO
  ENDDO
  DO j = 1,jmax
     wrk1d(j,1) = AVG_IK(imax, jmax, kmax, j, &
          txc(1,1,1,2), dx, dz, area)
  ENDDO
  CALL IO_WRITE_ASCII_FIELD('PM2SG_rans.dat', i1, jmax, i1, &
       wrk1d)
#endif

  RETURN
END SUBROUTINE SGS_ARM_P
