      SUBROUTINE SGS_ARM_RANS_PSG(imax, jmax, kmax, kmax_total,&
           area, rtime, x, y, z, dx, dy, dz, &
           p, p2_sg, wrk1d, wrk3d)

      IMPLICIT NONE

#include "types.h"
#include "integers.h"

      TINTEGER imax, jmax, kmax, kmax_total
      TREAL area, rtime

      TREAL x(imax)
      TREAL y(jmax)
      TREAL z(kmax_total)
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)

      TREAL p(imax,jmax,kmax)

      TREAL wrk1d(jmax,*) 
      TREAL wrk3d(imax,jmax,kmax) 

      TREAL p2_sg(jmax)

      TINTEGER k, ij, j
      TREAL EP_dns, EP_les
      TREAL SIMPSON_NU, AVG_IK

#ifdef SINGLE_PREC
      EP_dns = C_1EM4_R*( rtime*0.0099381e0 + 0.70635e0 )**2
#else
      EP_dns = C_1EM4_R*( rtime*0.0099381d0 + 0.70635d0 )**2
#endif


#define rP(j)          wrk1d(j,1)

      DO k = 1,kmax
         DO ij = 1,imax*jmax
            wrk3d(ij,1,k) = p(ij,1,k)*p(ij,1,k)
         ENDDO
      ENDDO
      DO j = 1,jmax
         p2_sg(j) = AVG_IK(imax, jmax, kmax, j, &
              wrk3d, dx, dz, area)
         rP(j) = AVG_IK(imax, jmax, kmax, j, &
              p, dx, dz, area)
         p2_sg(j) = p2_sg(j) - rP(j)*rP(j)
      ENDDO
      
      EP_les =  SIMPSON_NU(jmax,p2_sg(1),y)
      DO j = 1,jmax
         p2_sg(j) = p2_sg(j)*(EP_dns/EP_les-C_1_R)
      ENDDO
      
#ifdef _DEBUG
      CALL IO_WRITE_ASCII_FIELD('P2SG_rans.dat', i1, jmax, i1, &
           p2_sg(1))
#endif

#undef rP

      RETURN
      END
