      SUBROUTINE SGS_ARM_SPTL_INIT(iarm_spc, jmax, ng, nre, remin, &
           dre, wrk, c0)

      IMPLICIT NONE

#include "types.h"
#include "dns_error.h"
#include "nfile.h"

      TINTEGER jmax,iarm_spc
      TREAL remin, dre
      TINTEGER ng, nre
      TREAL wrk(*)
      TREAL c0(jmax)

      TINTEGER il, ire, ic0, j
      CHARACTER*24 line
      
      il = 1
      ire = il + ng*nre
      ic0 = ire + nre

!  CALL SGS_SPPR_TABLE(ng, remin, dre, nre, 
! $     wrk(il), wrk(ire), wrk(ic0))
! Use generalized Pope spectrum to generate c0 table
      IF ( iarm_spc .EQ. 1 ) THEN
         CALL SGS_ARM_TABLE_P(ng, remin, dre, nre, &
              wrk(il), wrk(ire), wrk(ic0))
      ELSE IF ( iarm_spc .EQ. 2 ) THEN
         CALL SGS_ARM_TABLE_A(ng, remin, dre, nre, &
              wrk(il), wrk(ire), wrk(ic0))
      ENDIF

! Initialize C0
      DO j=1, jmax
         c0(j) = C_1_R
      ENDDO
      
      CALL IO_WRITE_ASCII(lesfile, &
           '#################################################')
      CALL IO_WRITE_ASCII(lesfile, &
           '# Spectral Partial Reconstruction Table')
      CALL IO_WRITE_ASCII(lesfile, '# ')
      CALL IO_WRITE_ASCII(lesfile, &
           '# Integral Scale Parameters ')
      WRITE(line, *) ng
      CALL IO_WRITE_ASCII(lesfile, &
           '# Number of Points = '//line)
      WRITE(line, 111) EXP(wrk(1))
      CALL IO_WRITE_ASCII(lesfile, &
           '# Minimum Gamma = '//line)
      WRITE(line, 111) EXP(wrk(ng))
      CALL IO_WRITE_ASCII(lesfile, &
           '# Maximum Gamma = '//line)
      CALL IO_WRITE_ASCII(lesfile, &
           '# Turbulent Reynolds Number Parameters ')
      WRITE(line, *) nre
      CALL IO_WRITE_ASCII(lesfile, &
           '# Number of Points = '//line)
      WRITE(line, 111) EXP(wrk(ire))
      CALL IO_WRITE_ASCII(lesfile, &
           '# Minimum Length = '//line)
      WRITE(line, 111) EXP(wrk(ire+nre-1))
      CALL IO_WRITE_ASCII(lesfile, &
           '# Maximum Length = '//line)
      CALL IO_WRITE_ASCII(lesfile, &
           '# Table Outputs ')
      WRITE(line, 111) wrk(ic0)
      CALL IO_WRITE_ASCII(lesfile, &
           '# C0(1,1)    = '//line)
      WRITE(line, 111) wrk(ic0+ng-1)
      CALL IO_WRITE_ASCII(lesfile, &
           '# C0(ng,1)   = '//line)
      WRITE(line, 111) wrk(ic0+ng*(nre-1))
      CALL IO_WRITE_ASCII(lesfile, &
           '# C0(1,nre)  = '//line)
      WRITE(line, 111) wrk(ic0-1+ng*nre)
      CALL IO_WRITE_ASCII(lesfile, &
           '# C0(ng,nre) = '//line)
      CALL IO_WRITE_ASCII(lesfile, &
           '#################################################')

 111  FORMAT(e12.5)
      RETURN
      END
