      SUBROUTINE SGS_SPPR_C0(ipr, itime, ng, nre, &
           visc, imax, delta, kin, dis, wrk, c0, messageles)

      IMPLICIT NONE

#include "types.h"
#include "nfile.h"
#include "dns_error.h"

      TINTEGER ipr, itime
      TINTEGER ng, nre
      TINTEGER imax
      TREAL visc(imax), delta(imax), kin(imax), dis(imax)
      TREAL wrk(*)
      TREAL c0(imax)
      CHARACTER*(*) messageles

      TREAL ret, gamma, log_ret, log_gamma, SPL2
      TREAL remin, remax, gmin, gmax, c0min, c0max, c0mean
      TINTEGER i, ire, ic, ihit, l1, l2
      TINTEGER i0, i1
      CHARACTER*98 line

      i0 = 0
      i1 = 1

! Statistics
      ihit = 0

      remax = C_0_R
      remin = C_BIG_R
      
      gmax = C_0_R
      gmin = C_BIG_R
      
      c0max = C_0_R
      c0min = C_BIG_R
      c0mean = C_0_R

      ire = 1+ng
      ic = ire+nre

! Flow Parameters
      DO i=1, imax
         ret = kin(i)*kin(i)/(visc(i)*dis(i))
         
         IF ( ret .GT. C_10_R ) THEN

            gamma = C_05_R*(dis(i)*delta(i))/(kin(i)*SQRT(kin(i)))
            
            ihit = ihit + 1
            
            gmax = MAX(gamma,gmax)
            gmin = MIN(gamma,gmin)

            remax = MAX(remax, ret)
            remin = MIN(remin, ret)
            
!       Limit values to table limits
            log_gamma = LOG(gamma)
            log_gamma = MIN(log_gamma, wrk(ng))
            log_gamma = MAX(log_gamma, wrk(1))
            
            log_ret = LOG(ret)
            log_ret = MIN(log_ret, wrk(ire+nre-1))
            log_ret = MAX(log_ret, wrk(ire))
            
!       Interpolate Table
            c0(i) = SPL2(ng, wrk(1), nre, wrk(ire), wrk(ic), &
                 log_gamma, log_ret)
            
            c0mean = c0mean + c0(i)

!        WRITE(*,122) i, kin(i), dis(i), ret, gamma, c0(i)
! 122        FORMAT(I3,1X,5(1X,E10.3))
         ELSE
            c0(i) = C_1_R
         ENDIF
         
         c0min = MIN(c0min, c0(i))
         c0max = MAX(c0max, c0(i))
      ENDDO

      IF ( ipr .EQ. 1 ) THEN
         IF ( ihit .GT. 0 ) THEN
            c0mean = c0mean/ihit
         ENDIF
     
         WRITE(line,111) ihit, remin, remax, gmin, gmax, &
              c0min, c0max, c0mean
 111     FORMAT((I5,3X),7(1X,E10.3))
         CALL CLIP(line,l1,l2)
         messageles = messageles(1:LEN_TRIM(messageles))//'   '//line(l1:l2)
!     CALL IO_WRITE_ASCII(lesfile, line(l1:l2))
      ENDIF

      RETURN
      END
