! #############################################
! # Adhoc 1D spectrum
! #
! # p(1) - p1
! # p(2) - p2 
! # ...
! #
! #############################################

      FUNCTION ESP_A1D(x, p)

      IMPLICIT NONE

#include "types.h"

      TREAL x, p(*)
      TREAL eta
      TREAL ESP_A1D

      eta = x*EXP(-C_3_R/C_4_R*LOG(p(4)))
      ESP_A1D = p(6)/(x+p(3))**p(7)*EXP(-p(2)*eta**p(8))

!  IF ( x .GT. 70d0 ) ESP_A1D = C_0_R
!  xd = C_1_R
!  IF ( x .LT. xd ) THEN
!     eta = xd*EXP(-C_3_R/C_4_R*LOG(p(4)))
!     ESP_A1D = p(6)/(xd+p(3))**p(7)*EXP(-p(2)*eta**p(8))
!     ESP_A1D = C_0_R
!  ENDIF

      RETURN
      END

! ##################################################

      FUNCTION ESP_A1D_A0(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, norm
      TREAL FIL_2, ESP_A1D, ESP_A1D_A0

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A1D(C_1_R/params(9),params)

      ESP_A1D_A0 = -ESP_A1D(x, params)&
           *(C_1_R-G*G)*(C_1_R-G*G)
      ESP_A1D_A0 = ESP_A1D_A0/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A1D_A1(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_2, ESP_A1D, ESP_A1D_A1

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A1D(C_1_R/params(9),params)

      G2 = G*G
      ESP_A1D_A1 = C_2_R*ESP_A1D(x, params)*G2*&
           (C_1_R-G)*(C_1_R-G2)
      ESP_A1D_A1 = ESP_A1D_A1/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A1D_A2(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_2, ESP_A1D, ESP_A1D_A2

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A1D(C_1_R/params(9),params)
      
      G2 = G*G
      ESP_A1D_A2 = ESP_A1D(x, params)&
           *G2*(C_1_R-G)*(C_1_R-G)*(C_1_R-G2)
      ESP_A1D_A2 = ESP_A1D_A2/norm

      RETURN
      END

! ##################################################
