! #############################################
! # Adhoc spectrum
! #
! # p(1) - p1
! # p(2) - p2 
! # ...
! #
! #############################################

      FUNCTION ESP_A(x, p)

      IMPLICIT NONE

#include "types.h"

      TREAL x, p(*)
      TREAL F, eta
      TREAL ESP_A

      eta = x*EXP(-C_3_R/C_4_R*LOG(p(4)))

      F = p(6)/(x+p(3))**p(7)*EXP(-p(2)*eta**p(8))

      ESP_A = ( x*p(7)/(x+p(3)) + p(8)*p(2)*eta**p(8) ) * F 
!  ESP_A = ( c53*x/(x+p(1))**(C_8_R/C_3_R) + 
! $     C_2_R*p(2)*eta*eta/(x+p(1))**c53 ) * EXP(-p(2)*eta*eta)

      RETURN
      END

! ##################################################

      FUNCTION ESP_A_A0(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, norm
      TREAL FIL_2, ESP_A, ESP_A_A0

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A(C_1_R/params(9),params)

      ESP_A_A0 = -ESP_A(x, params)&
           *(C_1_R-G*G)*(C_1_R-G*G)
      ESP_A_A0 = ESP_A_A0/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A_A1(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_2, ESP_A, ESP_A_A1

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A(C_1_R/params(9),params)

      G2 = G*G
      ESP_A_A1 = C_2_R*ESP_A(x, params)*G2*&
           (C_1_R-G)*(C_1_R-G2)
      ESP_A_A1 = ESP_A_A1/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A_A2(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_2, ESP_A, ESP_A_A2

      S = params(9)*x
      G = FIL_2(S)
      norm = ESP_A(C_1_R/params(9),params)
      
      G2 = G*G
      ESP_A_A2 = ESP_A(x, params)&
           *G2*(C_1_R-G)*(C_1_R-G)*(C_1_R-G2)
      ESP_A_A2 = ESP_A_A2/norm

      RETURN
      END

! ##################################################
