SUBROUTINE CGBC2RSCU(imax, jmax, kmax, kmax_total, dx, dy, dz, rhs)

#include "types.h"
#include "dns_error.h"

#ifdef PARALLEL
  USE DNS_MPI
#endif

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif

  TINTEGER imax
  TINTEGER jmax
  TINTEGER kmax
  TINTEGER kmax_total
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TINTEGER i
  TREAL rhs(imax,jmax,kmax)
  TREAL diag
  TREAL chi
  TREAL eta
  TREAL rsc

  chi = (dy(jmax/2)/dx(imax/2))**2

  IF ( kmax_total .GT. 1 ) THEN
     eta = (dy(jmax/2)/dz(kmax_total/2))**2
  ELSE
     eta = C_0_R
  ENDIF

  diag = C_2_R*(C_1_R+chi+eta)

  rsc = (dy(jmax/2)**2) / diag

  DO i=1, imax*jmax*kmax
     rhs(i,1,1) = rhs(i,1,1)*rsc
  ENDDO

  RETURN
END SUBROUTINE CGBC2RSCU
