      SUBROUTINE CGMATRIXL(imax, jmax, kmax, i1bc, j1bc, k1bc, &
           chi, mu, eta, r, y, d)

      IMPLICIT NONE

#include "types.h"

      TINTEGER imax
      TINTEGER jmax
      TINTEGER kmax
      TINTEGER i1bc
      TINTEGER j1bc
      TINTEGER k1bc
      TINTEGER i
      TINTEGER j
      TINTEGER k
      TREAL r(imax, jmax, kmax)
      TREAL y(imax, jmax, kmax)
      TREAL d(imax, jmax, kmax)
      TREAL chi
      TREAL mu
      TREAL eta

      y(1,1,1) = r(1,1,1)/d(1,1,1)

      DO i=2, imax
         y(i,1,1) = (r(i,1,1) + chi * y(i-1,1,1))/d(i,1,1)
      ENDDO

      DO j=2, jmax
         y(1,j,1) = (r(1,j,1) + mu * y(1,j-1,1))/d(1,j,1)
      ENDDO

      DO k=2, kmax
         y(1,1,k) = (r(1,1,k) + eta * y(1,1,k-1))/d(1,1,k)
      ENDDO

      DO k=2, kmax
         DO j=2, jmax
            y(1,j,k) = ( r(1,j,k) + mu * y(1,j-1,k) + eta * y(1,j,k-1) )&
                 / d(1,j,k)
         ENDDO
      ENDDO

      DO j=2, jmax
         DO i=2, imax
            y(i,j,1) = ( r(i,j,1) + mu * y(i,j-1,1) + chi * y(i-1,j,1) )&
                 / d(i,j,1)
         ENDDO
      ENDDO

      DO k=2, kmax
         DO i=2, imax
            y(i,1,k) = ( r(i,1,k) + y(i-1,1,k) * chi &
                 + eta * y(i,1,k-1) ) / d(i,1,k)
         ENDDO
      ENDDO

      DO k=2, kmax
         DO j=2, jmax
            DO i=2, imax
               y(i,j,k) = ( r(i,j,k) + y(i-1,j,k) * chi &
                    + mu * y(i,j-1,k)&
                    + eta * y(i,j,k-1) ) / d(i,j,k)
            ENDDO
         ENDDO
      ENDDO

      RETURN
      END
