      SUBROUTINE CGMATRIXU(imax, jmax, kmax, i1bc, j1bc, k1bc, &
           chi, mu, eta, r, y, d)

      IMPLICIT NONE

#include "types.h"

      TINTEGER imax
      TINTEGER jmax
      TINTEGER kmax
      TINTEGER i1bc
      TINTEGER j1bc
      TINTEGER k1bc
      TINTEGER i
      TINTEGER j
      TINTEGER k
      TREAL r(imax, jmax, kmax)
      TREAL y(imax, jmax, kmax)
      TREAL d(imax, jmax, kmax)
      TREAL chi
      TREAL mu
      TREAL eta

      y(imax,jmax,kmax) = r(imax,jmax,kmax)

      DO i=imax-1, 1, -1
         y(i,jmax,kmax) = r(i,jmax,kmax) &
              + chi * y(i+1,jmax,kmax)/d(i,jmax,kmax)
      ENDDO

      DO j=jmax-1, 1, -1
         y(imax,j,kmax) = r(imax,j,kmax) &
              + mu * y(imax,j+1,kmax)/d(imax,j,kmax)
      ENDDO

      DO k=kmax-1, 1, -1
         y(imax,jmax,k) = r(imax,jmax,k) &
              + eta * y(imax,jmax,k+1)/d(imax,jmax,k)
      ENDDO

      DO k=kmax-1, 1, -1
         DO j=jmax-1, 1, -1
            y(imax,j,k) = r(imax,j,k) &
                 + ( mu * y(imax,j+1,k)&
                 + eta * y(imax,j,k+1) ) / d(imax,j,k)
         ENDDO
      ENDDO

      DO j=jmax-1, 1, -1
         DO i=imax, 1, -1
            y(i,j,kmax) = r(i,j,kmax) + &
                 ( mu * y(i,j+1,kmax) &
                 + chi * y(i+1,j,kmax) ) / d(i,j,kmax)
         ENDDO
      ENDDO

      DO k=kmax-1, 1, -1
         DO i=imax-1, 1, -1
            y(i,jmax,k) = r(i,jmax,k) + ( y(i+1,jmax,k) * chi &
                 + eta * y(i,jmax,k+1) ) / d(i,jmax,k)
         ENDDO
      ENDDO

      DO k=kmax-1, 1, -1
         DO j=jmax-1, 1, -1
            DO i=imax-1, 1, -1
               y(i,j,k) = ( r(i,j,k) + y(i+1,j,k) * chi &
                    + mu * y(i,j+1,k)&
                    + eta * y(i,j,k+1) ) / d(i,j,k)
            ENDDO
         ENDDO
      ENDDO

      RETURN
      END
