SUBROUTINE CHEM_BURKESCHUMANN(nx,ny,nz, z1, T, gama, TGF)
  
#include "types.h"
#include "dns_const.h"

  USE DNS_GLOBAL
  USE CHEM_GLOBAL

  IMPLICIT NONE
  
  TINTEGER nx, ny, nz
  TREAL, DIMENSION(nx,ny,nz)   :: T, gama, TGF
  TREAL, DIMENSION(nx,ny,nz,*) :: z1

  TREAL tgfmin, tgfmax
  TINTEGER ij,k,is,im,icp

  IF ( ireactive .EQ. CHEM_INFINITE ) THEN
     DO k=1, nz
        DO ij=1, nx*ny

#define MACRO_ZINPUT z1(ij,1,k,inb_scal)
#include "dns_chem_mass.h"

#define MACRO_TINPUT T(ij,1,k)
#include "dns_chem_enth.h"

           TGF(ij,1,k) = gama(ij,1,k)*(T(ij,1,k)*CH_G-CH_F/CPW)
        ENDDO
     ENDDO

     CALL MINMAX(nx,ny,nz, TGF, tgfmin,tgfmax)

     TGFM = MAX(ABS(tgfmin),ABS(tgfmax))*visc / (gama0*schmidt(inb_scal)*mach*mach)

  ELSE
     TGFM = C_0_R

  ENDIF

  RETURN
END SUBROUTINE CHEM_BURKESCHUMANN
