SUBROUTINE CHEM_QUASIBS(rho, T, GM, z1, zh1, h4)
  
#include "types.h"
#include "dns_error.h"
  
! This reaction mechanism differs only from the BS in:
!
! 1) Allows schmidt different from prandtl (D_Z != D_T) 
! 2) Explicit formulation of heat release term in energy equation
! 3) Develop for consistency with LES formulation of BS
!
! Juan Pedro Mellado, April 2006
  
  USE DNS_GLOBAL

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif

  TREAL rho(imax,jmax,kmax)
  TREAL T(imax,jmax,kmax)
  TREAL GM(imax,jmax,kmax)
  TREAL z1(imax,jmax,kmax,*)
  TREAL zh1(imax,jmax,kmax,*)
  TREAL h4(imax,jmax,kmax)

  CALL IO_WRITE_ASCII(efile, 'CHEM_QUASIBS: Not yet developed')
  CALL DNS_STOP(DNS_ERROR_UNDEVELOP)

  RETURN
END SUBROUTINE CHEM_QUASIBS
