SUBROUTINE THERMO_BURKESCHUMANN(nx, ny, nz, z1, rho)

  USE DNS_GLOBAL
  USE CHEM_GLOBAL

  IMPLICIT NONE

#include "types.h"

  TINTEGER nx, ny, nz

  TREAL, DIMENSION(nx*ny*nz) :: z1, rho

  TINTEGER i
  TREAL T, HE, CHW_ERROR, CHW_INC
  TINTEGER is, im, icp

  YMASS(1:NSP) = C_0_R

  T = C_1_R

  DO i = 1,nx*ny*nz

#define MACRO_HINPUT HE
#define MACRO_ZINPUT z1(i)
#include "dns_chem_mass.h"

     HE = (HOX + (HFUEL-HOX)*z1(i))

#define MACRO_TINPUT T
#include "dns_chem_inv.h"

! Density
     rho(i) = MRATIO*p_init*WMEAN/T

  ENDDO

  RETURN
END SUBROUTINE THERMO_BURKESCHUMANN
