SUBROUTINE CORR1DNP ( mode, nmax, a1, a2, crl )

! ######################################################
! # Correlation between a1 and a2, non-periodic
! # and output in crl
! #
! # mode = 1 for autocorrelation (only positive lag)
! # mode = 2 for crosscorrelation (pos./neg. lag)
! #
! # March 2001, Juan Pedro Mellado
! ######################################################

  IMPLICIT NONE

#include "types.h"

  TINTEGER mode
  TINTEGER nmax
  TREAL a1(nmax)
  TREAL a2(nmax)
  TREAL crl(*)

  TINTEGER n1, n2, offset, offsetmin, i1, p_crl

  i1 = 1

! Auto-correlation
  IF ( mode .EQ. 1 ) THEN 
     offsetmin = 0
! Cross-correlation
  ELSE IF ( mode .EQ. 2 ) THEN
     offsetmin = -nmax/2
  ENDIF

! Loop
  DO offset = offsetmin,nmax/2
     p_crl = offset + ABS(offsetmin) + 1
     crl(p_crl) = C_0_R
     DO n1 = MAX(-offset+i1,i1),MIN(nmax,nmax-offset)
        n2 = n1+offset
        crl(p_crl) = crl(p_crl) + a1(n1)*a2(n2)
     ENDDO
     crl(p_crl) = crl(p_crl)/M_REAL(nmax-ABS(offset))
  ENDDO

  RETURN
END SUBROUTINE CORR1DNP

