      SUBROUTINE CORR1DPN(nmax, a1, a2, acrl)

! ######################################################
! # Correlation between a1 and a2, assumed periodicity
! # and output in acrl
! # Variant of CORR1DPN w/o normalization
! ######################################################

      IMPLICIT NONE

#include "types.h"

      TINTEGER nmax
      TREAL a1(nmax)
      TREAL a2(nmax)
      TREAL acrl(nmax)

      TINTEGER n1, n2, offset

      DO offset = 1,nmax
         acrl(offset) = C_0_R
         DO n1 = 1,nmax
            n2 = n1+offset-1
            n2 = MOD(n2,nmax)
            IF ( n2 .EQ. 0 ) THEN
               n2 = nmax
            ENDIF
            acrl(offset) = acrl(offset) + a1(n1)*a2(n2)
         ENDDO
         acrl(offset) = acrl(offset)/M_REAL(nmax)
      ENDDO

      RETURN
      END

