      SUBROUTINE CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, u, ruy, &
           luy, area, wc, wrk)

      IMPLICIT NONE

#include "types.h"
#ifdef PARALLEL
#include "mpif.h"
#endif

      TINTEGER i, j, k, id
      TINTEGER imax, jmax, kmax
      TREAL dx(imax), y(jmax), dz(kmax)
      TREAL u(imax, jmax, kmax)
      TREAL wc(imax, jmax, kmax)
      TREAL ruy(jmax)
      TREAL wrk(jmax)
      TREAL luy, area, ruymax
      TREAL SIMPSON_NU
#ifdef PARALLEL
      INTEGER ims_pro, ims_err

      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ims_pro,ims_err)
#endif
      DO k=1, kmax
         DO id=1,jmax
            DO i=1, imax
               wc(i,id,k) = u(i,j,k)*u(i,id,k)
            ENDDO
         ENDDO
      ENDDO  

      CALL AVG_IK_V(imax, jmax, kmax, jmax, &
           wc, dx, dz, ruy, wrk, area)

#ifdef PARALLEL
      IF ( ims_pro .EQ. 0 ) THEN
#endif

      IF ( ruy(j) .NE. C_0_R ) THEN
         luy = SIMPSON_NU(jmax, ruy, y)/ruy(j)
         ruymax = ruy(j)
         DO id=1,jmax
            ruy(id) = ruy(id)/ruymax
         ENDDO
      ELSE
         luy = C_0_R
      ENDIF

#ifdef PARALLEL
      ENDIF
#endif

      RETURN
      END
