      SUBROUTINE CORR2V2PTZ(imax, jmax, kmax, j, dx, dz, u, v, ruz, &
           luz, ref, area, wc)

      IMPLICIT NONE

#include "types.h"

      TINTEGER i, j, k, id, index
      TINTEGER imax, jmax, kmax
      TREAL dx(imax), dz(kmax)
      TREAL u(imax, jmax, kmax)
      TREAL v(imax, jmax, kmax)
      TREAL wc(imax, jmax, kmax)
      TREAL ruz(kmax/2+1)
      TREAL luz, area, ref
      TREAL AVG_IK, SIMPSON
      TINTEGER klen

      IF ( kmax .EQ. 1 ) RETURN

      klen = kmax/2+1

      DO id=1,klen
         DO k=1, kmax
            index = k+id-2
            DO i=1, imax
               wc(i,j,k) = u(i,j,k)*&
                    v(i,j,MOD(index,kmax)+1)
            ENDDO    
         ENDDO
         ruz(id) = AVG_IK(imax, jmax, kmax, j, wc, dx, dz, area)
      ENDDO  

      IF ( ruz(1) .NE. C_0_R ) THEN
         luz = SIMPSON(klen, ruz, dz)/ruz(1)
         ref = ruz(1)
         DO id=1,klen
            ruz(id) = ruz(id)/ref
         ENDDO
      ELSE
         ref = C_0_R
         luz = C_0_R
      ENDIF

      RETURN
      END
