      SUBROUTINE CORRY(sbase, imax, jmax, kmax, itime, rtime, &
           u, v, w, p, T, rho, z1,&
           wc, area, y, dx, dy, dz, ruy, wrk)

      IMPLICIT NONE

#include "types.h"
#ifdef PARALLEL
#include "mpif.h"
#endif

      CHARACTER*(*) sbase
      TINTEGER imax, jmax, kmax, itime
      TREAL rtime, y(jmax)
      TREAL dx(imax), dy(jmax), dz(kmax)
      TREAL ruy(jmax,*)
      TREAL wrk(jmax)
      TREAL u(imax, jmax, kmax)
      TREAL v(imax, jmax, kmax)
      TREAL w(imax, jmax, kmax)
      TREAL p(imax, jmax, kmax)
      TREAL T(imax, jmax, kmax)
      TREAL rho(imax, jmax, kmax)
      TREAL z1(imax,jmax,kmax)
      TREAL wc(imax, jmax, kmax)
      TREAL area
      TREAL luy, lvy, lwy, lty, lsy, lpy, lry
      TINTEGER i, j
      CHARACTER*50 ofile
#ifdef PARALLEL
      INTEGER ims_pro, ims_err
#endif

#ifdef PARALLEL
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ims_pro,ims_err)

      IF ( ims_pro .EQ. 0 ) THEN
#endif

      WRITE(ofile,*) itime; ofile = TRIM(ADJUSTL(sbase))//TRIM(ADJUSTL(ofile))
      
      OPEN(unit=21,file=ofile)
      
      WRITE(21,'(A8,E14.7E3)') 'RTIME = ', rtime
      WRITE(21, '(A8)') 'IMAX = 1'
      WRITE(21, '(A7,I8)') 'JMAX = ', jmax
      WRITE(21, 1010) 'GROUP = Correlations '&
           //'Ruu(ry) Rvv(ry) Rww(ry) Rpp(ry) Rtt(ry) Rrr(ry) Rss(ry)'
      WRITE(21, 1010) 'GROUP = Integral_scales '&
           //'Lu Lv Lw Lp Lt Lr Ls'
      WRITE(21, 1010) 'I J Y '&
           //'Ruu(ry) Rvv(ry) Rww(ry) Rpp(ry) Rtt(ry) Rrr(ry) Rss(ry) '&
           //'Lu Lv Lw Lp Lt Lr Ls'
 1010 FORMAT(A)

#ifdef PARALLEL
      ENDIF
#endif

      DO j=1, jmax
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, u, ruy(1,1), &
              luy, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, v, ruy(1,2), &
              lvy, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, w, ruy(1,3), &
              lwy, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, p, ruy(1,4), &
              lpy, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, T, ruy(1,5), &
              lty, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, rho,ruy(1,6), &
              lry, area, wc, wrk)
         CALL CORR1V2P2DNY(imax, jmax, kmax, j, y, dx, dz, z1,ruy(1,7), &
              lsy, area, wc, wrk)

#ifdef PARALLEL
      IF ( ims_pro .EQ. 0 ) THEN
#endif         
         DO i=1, jmax
            IF ( i .NE. j ) THEN
               WRITE(21,1040) 1, j, y(i)-y(j), &
                    ruy(i,1), ruy(i,2), ruy(i,3), &
                    ruy(i,4), ruy(i,5), ruy(i,6), ruy(i,7)
            ELSE
               WRITE(21,1030) 1, j, y(1),&
                    1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,&
                    luy, lvy, lwy, lpy, lty, lry, lsy
            ENDIF
         ENDDO

#ifdef PARALLEL
      ENDIF
#endif
         
      ENDDO

 1030 FORMAT(I3,1X,I3,15(1X,E10.3E3))
 1040 FORMAT(I3,1X,I3,8(1X,E10.3E3))

#ifdef PARALLEL
      IF ( ims_pro .EQ. 0 ) THEN
#endif      
      CLOSE(21)
#ifdef PARALLEL
      ENDIF
#endif

      RETURN
      END
