SUBROUTINE STRUCTX(nx,ny,nz, j, u, nmom, rux, tmp)

  IMPLICIT NONE

#include "types.h"
#ifdef PARALLEL
#include "mpif.h"
#endif

#include "integers.h"

  TINTEGER nx, ny, nz, j, nmom

  TREAL, DIMENSION(nx,ny,nz)      :: u
  TREAL, DIMENSION(nx,nz)         :: tmp
  TREAL, DIMENSION(nx/2+1,2,nmom) :: rux

! -------------------------------------------------------------------
  TINTEGER i, k, id, index, idmax, im
  TREAL AVG1V3D
#ifdef PARALLEL
  INTEGER ims_pro, ims_err

  CALL MPI_COMM_RANK(MPI_COMM_WORLD,ims_pro,ims_err)
#endif

! maximum translational off-set in X
  idmax = nx/2

! saving along second index in tmp the 
! product of the signal with its translation defined by idlocal
  DO id = 0,idmax

      DO k = 1,nz
        DO i = 1,nx
           index = i + id; index = index + nx - 1; index = MOD(index,nx)+1
           tmp(i,k) = u(index,j,k) - u(i,j,k)
        ENDDO
     ENDDO

! Differences
     DO im = 1,nmom
        rux(id+1,1,im) = AVG1V3D(nx,i1,nz, im, tmp)
     ENDDO

! Increments; abs
     tmp = abs(tmp)
     DO im = 1,nmom
        rux(id+1,2,im) = AVG1V3D(nx,i1,nz, im, tmp)
     ENDDO


  ENDDO

  RETURN
END SUBROUTINE STRUCTX
