#include "types.h"

SUBROUTINE DNS_END(ic)
  
  USE DNS_CONSTANTS, ONLY : lfile, efile

#ifdef PARALLEL
  USE DNS_MPI
#endif

  IMPLICIT NONE
  
#ifdef PARALLEL
#include "mpif.h"
#endif
  
  INTEGER ic

#ifdef PARALLEL
  CHARACTER*64 line
#endif
  
  IF ( ic .EQ. 0 ) THEN; CALL IO_WRITE_ASCII(lfile, 'Finalizing program.')
  ELSE;                  CALL IO_WRITE_ASCII(lfile, 'Finalizing program abnormaly. Check'//TRIM(ADJUSTL(efile)) ); ENDIF
  CALL IO_WRITE_ASCII(lfile, '########################################')
  
#ifdef PARALLEL
  ims_time_max = MPI_WTIME()
  WRITE(line,'(E12.5E3)') ims_time_max-ims_time_min
  line = 'Time elapse ....................: '//TRIM(ADJUSTL(line))
  CALL IO_WRITE_ASCII(lfile, line)
 
#ifdef PROFILE_ON 
  WRITE(line,'(E12.5E3)') ims_time_trans
  line = 'Time in array transposition ....: '//TRIM(ADJUST(line))
  CALL IO_WRITE_ASCII(lfile, line)
#endif

#endif
      
#ifdef PARALLEL
  CALL MPI_FINALIZE(ims_err)
#endif
  
  RETURN
END SUBROUTINE DNS_END
