!########################################################################
!# Tool/Library
!#
!########################################################################
!# HISTORY
!#
!# 2007/09/11 - J.P. Mellado
!#              Created
!#
!########################################################################
!# DESCRIPTION
!#
!# Calculate the scalar gradient as given by G_i G_i, where G_i is dZ/dx_i
!#
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
#include "types.h"

SUBROUTINE FI_GRADIENT(imode_fdm, nx,ny,nz, i1bc,j1bc,k1bc, &
     dx,dy,dz, s, result, tmp1,tmp2, wrk1d,wrk2d,wrk3d)

  IMPLICIT NONE

#include "integers.h"

  TINTEGER imode_fdm, nx,ny,nz, i1bc,j1bc,k1bc

  TREAL, DIMENSION(*)        :: dx, dy, dz
  TREAL, DIMENSION(nx*ny*nz) :: s, result, tmp1, tmp2
  TREAL, DIMENSION(*)        :: wrk1d, wrk2d, wrk3d

! -------------------------------------------------------------------

! ###################################################################
  CALL PARTIAL_X(imode_fdm, nx,ny,nz, i1bc, dx, s,tmp1, i0,i0, wrk1d,wrk2d,wrk3d)
  CALL PARTIAL_Y(imode_fdm, nx,ny,nz, j1bc, dy, s,tmp2, i0,i0, wrk1d,wrk2d,wrk3d)
  result = tmp1*tmp1 + tmp2*tmp2
  CALL PARTIAL_Z(imode_fdm, nx,ny,nz, k1bc, dz, s,tmp2, i0,i0, wrk1d,wrk2d,wrk3d)
  result = result + tmp2*tmp2

  RETURN
END SUBROUTINE FI_GRADIENT
