      SUBROUTINE FDF_BETA_STO(imax, jmax, kmax, z_s, z1, z2sg, fdf_zs)

      IMPLICIT NONE

#include "types.h"

      TINTEGER imax, jmax, kmax
      TREAL z_s
      TREAL z1(imax,jmax,kmax)
      TREAL z2sg(imax,jmax,kmax)
      TREAL fdf_zs(imax,jmax,kmax)
      
      TINTEGER ij, k
      TREAL dtmp, eps, ln_Zs, ln_rZs, beta, a, b
      TREAL GAMMLN

      eps = C_1EM6_R
      ln_Zs = LOG(z_s)
      ln_rZs = LOG(1-z_s)

      DO k = 1,kmax
         DO ij = 1,imax*jmax

            dtmp = z1(ij,1,k)*(C_1_R-z1(ij,1,k))-z2sg(ij,1,k)
            IF ( dtmp .LE. eps ) THEN
               fdf_zs(ij,1,k) = C_0_R
            ELSE IF ( z2sg(ij,1,k) .LE. eps ) THEN
               fdf_zs(ij,1,k) = C_0_R
            ELSE
               a = z1(ij,1,k)*dtmp/z2sg(ij,1,k)
               b = a*(C_1_R/z1(ij,1,k)-C_1_R)
! watch out ! if a is less than zero, it is wrong and function
! gammln stops the code 
               beta = GAMMLN(a) + GAMMLN(b) - GAMMLN(a+b) 
               fdf_zs(ij,1,k) = EXP( (a-1)*ln_Zs+(b-1)*ln_rZs - beta )
            ENDIF

         ENDDO
      ENDDO

#ifdef _DEBUG
      CALL IO_WRITE_ASCII_FIELD('fdf.dat', imax, jmax, kmax, fdf_zs)
#endif

      RETURN
      END
