SUBROUTINE LES_LOGS(iflag)

#include "types.h"
#include "les_const.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL
  USE NFILE,     ONLY : lesfile

  IMPLICIT NONE

#include "integers.h"

  TINTEGER iflag

! -----------------------------------------------------------------------
  TINTEGER l, l2, ll2
  CHARACTER*256 line1
  CHARACTER*256 line2

! #######################################################################
! Headers
! #######################################################################
  IF ( iflag .EQ. 1 ) THEN
     line1='#  Itn.    DUMax      DEMax      DZMax     #'
     l2=LEN(TRIM(line1))

     IF ( iles_type_regu .EQ. LES_REGU_SMGDYN      .OR. &
          iles_type_regu .EQ. LES_REGU_SMGDYNRMS ) THEN
        line2=' CUMax      CEMax      CZMax     #'
        ll2=LEN(TRIM(line2))
        line1=line1(1:l2-1)//line2(1:ll2)
        l2=LEN(TRIM(line1))
     ENDIF

     IF ( iles_type_tran .EQ. LES_TRAN_NONE ) THEN
     ELSEIF ( iles_type_tran .EQ. LES_TRAN_ARMSPTL ) THEN
!        CALL IO_WRITE_ASCII(lesfile,'|   I     Hits      Min Re     Max Re     Min L  '&
!             //'    Max L      Min c0     Max c0    Mean c0 |')
     ELSE
        line2=' AUMax      AEMax      AZMax     #'
        ll2=LEN(TRIM(line2))
        line1=line1(1:l2-1)//line2(1:ll2)
        l2=LEN(TRIM(line1))
     ENDIF

!     IF ( iles_type_chem .EQ. LES_CHEM_STAT_BS ) THEN
!        CALL IO_WRITE_ASCII(lesfile,'|  I     nu_max      D_max      Cs_max     CsZ_max'
! $           //'    Hits(%)    Min Re     Max Re     Min L     Max L     Max c0  |')
!     ENDIF

     DO l = 1,l2
        line2(l:l)='#'
     ENDDO
     CALL IO_WRITE_ASCII(lesfile, line2(1:l2))
     CALL IO_WRITE_ASCII(lesfile, line1(1:l2))
     CALL IO_WRITE_ASCII(lesfile, line2(1:l2))
     
  ENDIF

! #######################################################################
! Construct line with data
! #######################################################################
  IF ( iflag .EQ. 2 ) THEN
! -----------------------------------------------------------------------
! Common general data
! -----------------------------------------------------------------------
     WRITE(line1,100) i0, itime, smg_udiff, smg_ediff, smg_zdiff
     l2=LEN(TRIM(line1))
     
100  FORMAT(1X,I1,1X,I7,3(1X,E10.3))
     
! Dynamic part
     IF ( iles_type_regu .EQ. LES_REGU_SMGDYN      .OR. &
          iles_type_regu .EQ. LES_REGU_SMGDYNRMS ) THEN
        WRITE(line2,200) smg_ucoef, smg_ecoef, smg_zcoef
        
        ll2=LEN(TRIM(line2))
        line1=line1(1:l2)//line2(1:ll2)
        l2=LEN(TRIM(line1))
        
200     FORMAT(3(1X,E10.3))
     ENDIF

! Reconstruction part
     IF ( iles_type_tran .EQ. LES_TRAN_NONE ) THEN
     ELSE
        WRITE(line2,300) arm_ucoef, arm_zcoef, arm_pcoef
        
        ll2=LEN(TRIM(line2))
        line1=line1(1:l2)//line2(1:ll2)
        l2=LEN(TRIM(line1))
        
300     FORMAT(3(1X,E10.3))
     ENDIF

! -----------------------------------------------------------------------
! Output
! -----------------------------------------------------------------------
     l2=LEN(TRIM(line1))
     CALL IO_WRITE_ASCII(lesfile, line1(1:l2))

  ENDIF
     
  RETURN
END SUBROUTINE LES_LOGS
