      SUBROUTINE SGS_ARM(ii, dx, dy, dz, rho, u, v, w, p, z1, vis,
     $     h1, h2, h3, h4, zh1, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5,
     $     wrk1d, wrk2d, wrk3d, wrk, c0, dis, messageles)

      IMPLICIT NONE

#include "types.h"
#include "dns_const.h"
#include "dns_error.h"
#include "param.h"
#include "common.h"

      TINTEGER ii
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)

      TREAL rho(imax, jmax, kmax)
      TREAL u(imax, jmax, kmax)
      TREAL v(imax, jmax, kmax)
      TREAL w(imax, jmax, kmax)
      TREAL p(imax, jmax, kmax)
      TREAL z1(imax, jmax, kmax)
      TREAL vis(imax, jmax, kmax)

      TREAL h1(imax, jmax, kmax)
      TREAL h2(imax, jmax, kmax)
      TREAL h3(imax, jmax, kmax)
      TREAL h4(imax, jmax, kmax)
      TREAL zh1(imax, jmax, kmax)

      TREAL tmp0(imax, jmax, kmax)
      TREAL tmp1(imax, jmax, kmax)
      TREAL tmp2(imax, jmax, kmax)
      TREAL tmp3(imax, jmax, kmax)
      TREAL tmp4(imax, jmax, kmax)
      TREAL tmp5(imax, jmax, kmax)
      
      TREAL wrk1d(ijkmax,MX1D)
      TREAL wrk2d(ijmax, MX2D)
      TREAL wrk3d(imax, jmax, kmax)
      TREAL wrk(*), c0(jmax), dis(jmax)
      CHARACTER*(*) messageles

      TREAL ru, rv, rw, AVG_IK
      TINTEGER ij, i,j,k
      TINTEGER i0, i1, i2, i3, n, ip

      i0 = 0
      i1 = 1
      i2 = 2
      i3 = 3
      n = 2

      IF ( isim_mode .NE. DNS_MODE_TEMPORAL ) THEN
         CALL OUTPUT(efile, 
     $        'SPPR SGS Model only works in temporal configuration')
         CALL DNS_STOP(DNS_ERROR_SPPR)
      ENDIF

      IF ( .NOT. ( iflow_mode .EQ. DNS_FLOW_SHEAR .OR. 
     $           iflow_mode .EQ. DNS_FLOW_JET ) ) THEN
         CALL OUTPUT(efile, 
     $        'SPPR SGS Model only works for Shears/Jets')
         CALL DNS_STOP(DNS_ERROR_SPPR)
      ENDIF

c     --------   Calculate Estimated Velocity Fields   --------
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, u, tmp2, wrk3d)

      DO k=1, kmax
         DO j=1,jmax
            DO i=1,imax
               tmp2(i,j,k) = u(i,j,k) + c0(j)*
     $              (u(i,j,k)-tmp2(i,j,k))
            ENDDO
         ENDDO
      ENDDO

      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, v, tmp3, wrk3d)

      DO k=1, kmax
         DO j=1,jmax
            DO i=1,imax
               tmp3(i,j,k) = v(i,j,k) + c0(j)*
     $              (v(i,j,k)-tmp3(i,j,k))
            ENDDO
         ENDDO
      ENDDO

      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp2, tmp4, wrk3d)

      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp3, tmp5, wrk3d)

c     ###############################################

c     tmp0 = wrk
c     tmp1 = wrk
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = f(U_m)
c     tmp5 = f(V_m)
      
c     ###############################################
c     #                    UxU

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp2(ij,1,k)*tmp2(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp4(ij,1,k)*tmp4(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, u, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h1(ij,1,k) = h1(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     ###############################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = f(U_m)
c     tmp5 = f(V_m)

c     ###############################################
c     #                    UxV

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp2(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp4(ij,1,k)*tmp5(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, v, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, u, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h2(ij,1,k) = h2(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h1(ij,1,k) = h1(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     ###############################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = f(U_m)
c     tmp5 = f(V_m)

c     ###############################################
c     #                    VxV

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp3(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp5(ij,1,k)*tmp5(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, v, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h2(ij,1,k) = h2(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     ######################################################
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, w, tmp4, wrk3d)

      DO k=1, kmax
         DO j=1,jmax
            DO i=1,imax
               tmp4(i,j,k) = w(i,j,k) + c0(j)*
     $              (w(i,j,k)-tmp4(i,j,k))
            ENDDO
         ENDDO
      ENDDO

      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp4, tmp5, wrk3d)

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = f(W_m)

c     ###############################################
c     #                    UxW

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp2(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp2, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp0(ij,1,k)*tmp5(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, w, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, u, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h1(ij,1,k) = h1(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h3(ij,1,k) = h3(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     ###############################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = f(W_m)

c     ###############################################
c     #                    WxW

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp4(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp5(ij,1,k)*tmp5(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, w, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h3(ij,1,k) = h3(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO
      
c     #########################################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = f(W_m)

c     ###############################################
c     #                    VxW

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp3(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp3, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp0(ij,1,k)*tmp5(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

c     ********  Towards Turbulent Dissipation at the end   *******
      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, w, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, v, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            wrk3d(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO

      DO j=1, jmax
         dis(j) = dis(j) + AVG_IK(imax, jmax, kmax, j, wrk3d, dx, dz, 
     $        area)
      ENDDO
c     ************************************************************

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h2(ij,1,k) = h2(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h3(ij,1,k) = h3(ij,1,k) -  sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     -------------    Calculate Kinetic Energy ------------------
      DO j=1, jmax
         ru = AVG_IK(imax, jmax, kmax, j, u, dx, dz, 
     $        area)
         rv = AVG_IK(imax, jmax, kmax, j, v, dx, dz, 
     $        area)
         rw = AVG_IK(imax, jmax, kmax, j, w, dx, dz, 
     $        area)

         DO k=1, kmax
            DO i=1, imax
               wrk3d(i,1,k) = ( (u(i,j,k)-ru)**2 +
     $              (v(i,j,k)-rv)**2 +
     $              (w(i,j,k)-rw)**2 )*C_05_R
               wrk3d(i,2,k) = visc*vis(i,j,k)/rho(i,j,k)
            ENDDO
         ENDDO

         wrk1d(j,1) = AVG_IK(imax, jmax, kmax, i1, wrk3d, dx, dz, 
     $        area)
         wrk1d(j,2) = AVG_IK(imax, jmax, kmax, i2, wrk3d, dx, dz, 
     $        area)
         dis(j) = ABS(dis(j))
      ENDDO

      IF ( MOD(itime,nitera_log) .EQ. 0 .AND. ii .EQ. 1 ) THEN
         ip = 1
      ELSE
         ip = 0
      ENDIF

c     Here we assume that Delta_f = 2 Delta(grid)
      DO j = 1,jmax
         wrk1d(j,3) = C_2_R*dy(j)
      ENDDO
      CALL SGS_SPPR_C0(ip, itime, iarm_nl, iarm_nre, wrk1d(1,2), 
     $     jmax, wrk1d(1,3), wrk1d(1,1), dis, wrk, c0, messageles)

c     ###############################################

      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, p, tmp5, wrk3d)
      
      DO k=1, kmax
         DO j=1,jmax
            DO i=1,imax
               tmp5(i,j,k) = p(i,j,k) + c0(j)*
     $              (p(i,j,k)-tmp5(i,j,k))
            ENDDO
         ENDDO
      ENDDO

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = P_m

c     ###############################################
c     #                    PxV

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp3, tmp0, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp5, tmp3, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp1(ij,1,k)-tmp0(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h4(ij,1,k) = h4(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     #######################################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = f(P_m)
c     tmp4 = W_m
c     tmp5 = P_m

c     ###############################################
c     #                    PxW

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp4, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp1(ij,1,k)-tmp0(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h4(ij,1,k) = h4(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     #######################################################

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = f(P_m)
c     tmp4 = W_m
c     tmp5 = P_m

c     ###############################################
c     #                    PxU

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp2(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp2, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp1(ij,1,k)-tmp0(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            h4(ij,1,k) = h4(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     ############################################################
c     #                         SCALAR
c     ############################################################

      IF ( icalc_scalar .EQ. 1 ) THEN

         CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $        n, n, n, v, tmp3, wrk3d)
      
         DO k=1, kmax
            DO j=1,jmax
               DO i=1,imax
                  tmp3(i,j,k) = v(i,j,k) + c0(j)*
     $                 (v(i,j,k)-tmp3(i,j,k))
               ENDDO
            ENDDO
         ENDDO

         CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $        n, n, n, z1, tmp5, wrk3d)
      
         DO k=1, kmax
            DO j=1,jmax
               DO i=1,imax
                  tmp5(i,j,k) = z1(i,j,k) + c0(j)*
     $                 (z1(i,j,k)-tmp5(i,j,k))
               ENDDO
            ENDDO
         ENDDO

c     tmp0 = 
c     tmp1 =
c     tmp2 = U_m
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = Z_m

c     ###############################################
c     #                    ZxU

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp2(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp2, tmp0, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp5, tmp2, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp2(ij,1,k)*tmp0(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc, dx, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            zh1(ij,1,k) = zh1(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     tmp0 = 
c     tmp1 =
c     tmp2 = f(Z_m)
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = Z_m

c     ###############################################
c     #                    ZxV

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp3, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp0(ij,1,k)*tmp2(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc, dy, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            zh1(ij,1,k) = zh1(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO

c     tmp0 = 
c     tmp1 =
c     tmp2 = f(Z_m)
c     tmp3 = V_m
c     tmp4 = W_m
c     tmp5 = Z_m

c     ###############################################
c     #                    ZxW

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = tmp5(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO
      
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp0, tmp1, wrk3d)
      CALL LESTHF(i3, imax, jmax, kmax, kmax_total, 
     $     n, n, n, tmp4, tmp0, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            tmp0(ij,1,k) = (tmp1(ij,1,k)-tmp0(ij,1,k)*tmp2(ij,1,k))
     $           *rho(ij,1,k)
         ENDDO
      ENDDO

      CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc, dz, tmp0, tmp1, 
     $     i0, i0, wrk1d, wrk2d, wrk3d)

      DO k=1, kmax
         DO ij=1,NN
            zh1(ij,1,k) = zh1(ij,1,k) - sgs_alpha*tmp1(ij,1,k)
         ENDDO
      ENDDO
      ENDIF

      RETURN
      END
