      SUBROUTINE SGS_DYNCF2(ii, statflg, dyn_coef, dyn_diff, x,
     $     dx, dy, dz, rho, sij, frc, diff, wrk1d, wrk2d, wrk3d,
     $     numerator, denominator)

      IMPLICIT NONE

#include "types.h"
#include "common.h"
#include "dns_const.h"
#ifdef PARALLEL
#include "mpif.h"
#endif

      TINTEGER ii, statflg
      TREAL dyn_coef, dyn_diff
      TREAL x(imax)
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)
      TREAL rho(imax,jmax,kmax)
      TREAL sij(imax,jmax,kmax)
      TREAL frc(imax,jmax,kmax,2)
      TREAL diff(imax,jmax,kmax)
      TREAL wrk1d(ijkmax,*)
      TREAL wrk2d(ijmax,*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL numerator(*), denominator(*)

      TINTEGER i, j, k, ij
      TREAL Q9SMAX, AVG_IK, ABSMAX
      TREAL dummax
      TINTEGER i1

#ifdef TRACE_ON
      CALL OUTPUT(trfile, 'ENTERING SGS_DYNCF')
#endif

      i1 = 1

c #################################################
c # Calculate spatial average of dynamic coefficie#
c # Clip it to positive values for stability      #        
c # Stored in wrk1d(1,1) or wrk2d(1,1)            #
c #################################################
      IF ( isim_mode .EQ. DNS_MODE_TEMPORAL ) THEN
c#ifdef _DEBUG
c      IF ( ii .EQ. 1 ) THEN
c         CALL IO_WRITE_ASCII_FIELD('num.dat', i1, jmax, i1, numerator)
c         CALL IO_WRITE_ASCII_FIELD('den.dat', i1, jmax, i1, denominator)
c      ENDIF
c#endif
c         dummax = C_1EM3_R*ABSMAX(jmax,denominator)
c         DO j = 1,jmax
c            wrk1d(j,1) = numerator(j)/(denominator(j)+dummax)
c            wrk1d(j,1) = numerator(j)/denominator(j)
c         ENDDO
         DO k = 1,kmax
            DO ij = 1,NN
               wrk3d(ij,1,k) = frc(ij,1,k,1)/frc(ij,1,k,2)
            ENDDO
         ENDDO
         DO j = 1,jmax
            wrk1d(j,1) = AVG_IK(imax, jmax, kmax, j, wrk3d, 
     $           dx, dz, area)
         ENDDO

      ELSE IF ( isim_mode .EQ. DNS_MODE_SPATIAL ) THEN
      ENDIF

      IF ( ( MOD(itime,nitera_log) .EQ. 0 .AND. ii .EQ. 1 ) .OR.
     $     statflg .EQ. 1 ) THEN
         IF ( isim_mode .EQ. DNS_MODE_TEMPORAL ) THEN
            dyn_coef = Q9SMAX(wrk1d(1,1),jmax)
         ELSE IF ( isim_mode .EQ. DNS_MODE_SPATIAL ) THEN
            dyn_coef = Q9SMAX(wrk2d(1,1),NN)
         ENDIF
      ENDIF

c #######################################################
c #     txc(1) is rho*nu_s = rho*dyn_coef*sgs_delta^2*S #
c #######################################################
      IF ( isim_mode .EQ. DNS_MODE_TEMPORAL ) THEN
c         DO k = 1,kmax
c            DO j = 1,jmax
c               DO i = 1,imax
c                  diff(i,j,k) = wrk1d(j,1)*sij(i,j,k)
c               ENDDO
c            ENDDO
c         ENDDO
         DO k = 1,kmax
            DO ij = 1,NN
               diff(ij,1,k) = wrk3d(ij,1,k)*sij(ij,1,k)
            ENDDO
         ENDDO
      ELSE IF ( isim_mode .EQ. DNS_MODE_SPATIAL ) THEN
         DO k = 1,kmax
            DO ij = 1,NN
               diff(ij,1,k) = wrk2d(ij,1)*sij(ij,1,k)
            ENDDO
         ENDDO
      ENDIF

c #################################################
c # Obtain maximum nu_s for D# restriccion        #
c # The maximum over the PEs is done in courant.f #
c # but we need it for dns.les                    #
c #################################################
      DO k = 1,kmax
         DO ij = 1,NN
            wrk3d(ij,1,k) =  diff(ij,1,k)/rho(ij,1,k)
         ENDDO
      ENDDO
      dyn_diff = Q9SMAX(wrk3d,NN*kmax)
#ifdef PARALLEL
      CALL MPI_ALLREDUCE(dyn_diff, dummax, 1, MPI_REAL8, MPI_MAX, 
     $     MPI_COMM_WORLD, ims_err)
      dyn_diff = dummax
#endif

#ifdef TRACE_ON
      CALL OUTPUT(trfile, 'LEAVING SGS_DYNCF' )
#endif

      RETURN
      END
