      SUBROUTINE SGS_DYN_ARM_Z(n0, n1, x, y, z, dx, dy, dz, &
           rho, z1, barvs, &
           txc, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z,&
           cf1x, cf1y, cf1z, cf2x, cf2y, cf2z, carm_zf, carm_zh)
      
! # barvs(1) = 1/bar1(bar0(rho))          
! # barvs(2) = 1/bar0(bar0(rho))             
! # barvs(3) = 1/bar1(bar0(bar1(bar0(rho)))) 

! txc size is 5

  USE DNS_GLOBAL
  USE LES_GLOBAL

      IMPLICIT NONE

#include "types.h"
#include "les_const.h"
#include "integers.h"

      TINTEGER n0, n1
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)
      TREAL x(imax)
      TREAL y(jmax)
      TREAL z(kmax_total)
      TREAL rho(imax,jmax,kmax)
      TREAL z1(imax,jmax,kmax)
      TREAL barvs(imax,jmax,kmax,*)
      TREAL wrk1d(isize_wrk1d,*)
      TREAL wrk2d(*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL txc(imax,jmax,kmax,*)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      TREAL cf1x(*), cf1y(*), cf1z(*)
      TREAL cf2x(*), cf2y(*), cf2z(*)
      TREAL carm_zf(*), carm_zh(*)

      TINTEGER ij, j, k
      TREAL r0, r1
!  TREAL SIMPSON_NU, a0_int, a1_int, a2_int, c0_int

      r0 = C_0_R
      r1 = C_1_R

#define RHOZ2_SG(j)  wrk1d(j,1)
#define A0(j)        wrk1d(j,2)
#define A1(j)        wrk1d(j,3)
#define A2(j)        wrk1d(j,4)

!#define BARRZ(i,j,k)    txc(i,j,k,1)
!#define TMP1_LOC(i,j,k) txc(i,j,k,2)

! ARM inviscid
      IF ( iles_type_tran .EQ. LES_TRAN_ARMINVS ) THEN
         DO j = 1,jmax
!        carm_zf(j) = arm_c0_inviscid
            carm_zh(j) = arm_c0_inviscid
         ENDDO

! ARM rans
      ELSE IF ( iles_type_tran .EQ. LES_TRAN_ARMRANS ) THEN
! ################################
! #    calculating c0 at level F #
! ################################
!  IF ( iles_type_regu .EQ. LES_REGU_SMGDYNRMS ) THEN 
!c ----------------------------------------------------------------
!c                               calculating average <rho*(Z^2)_sg>
!c ----------------------------------------------------------------
!c     Use from A0 as wrk1d array
!     CALL SGS_ARM_RANS_ZSG(imax, jmax, kmax, kmax_total,
! $        area, rtime, r1, scaley, x, y, z, dx, dy, dz, 
! $        rho, z1, RHOZ2_SG(1), A0(1), wrk3d)
!
!c ----------------------------------------------------------------
!c                                      calculating the coefficient
!c ----------------------------------------------------------------
!     DO k = 1,kmax
!        DO ij = 1,imax*jmax
!           BARRZ(ij,1,k) = rho(ij,1,k)*z1(ij,1,k)
!        ENDDO
!     ENDDO
!c     txc size is 4
!     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,
! $        i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,
! $        dx, dy, dz, rho, barvs(1,1,1,2), 
! $        BARRZ(1,1,1), RHOZ2_SG(1), 
! $        A0(1), A1(1), A2(1), 
! $        cf0x, cf0y, cf0z, TMP1_LOC(1,1,1), wrk3d)
!     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), 
! $        A2(1), carm_zf)
!c         a0_int = SIMPSON_NU(jmax,A0(1),y)
!c         a1_int = SIMPSON_NU(jmax,A1(1),y)
!c         a2_int = SIMPSON_NU(jmax,A2(1),y)
!c         CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!c         DO j = 1,jmax
!c            carm_zf(j) = c0_int
!c         ENDDO
!
!  ENDIF
!
!#undef BARRZ
!#undef TMP1_LOC

#define R_H(i,j,k)      txc(i,j,k,1)
#define Z_H(i,j,k)      txc(i,j,k,2)
#define TMP1_LOC(i,j,k) txc(i,j,k,3)

! ################################
! #    calculating c0 at level H #
! ################################
! ----------------------------------------------------------------
!                           calculating average <rho*(Z^2)_sg>
! ----------------------------------------------------------------
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               TMP1_LOC(ij,1,k) = rho(ij,1,k)*z1(ij,1,k)
            ENDDO
         ENDDO
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
              Z_H(1,1,1), wrk3d)
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n1, cf1x, cf1y, cf1z, rho, &
              R_H(1,1,1), wrk3d)
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               Z_H(ij,1,k) = Z_H(ij,1,k)/R_H(ij,1,k)
            ENDDO
         ENDDO
         CALL SGS_ARM_RANS_ZSG(imax, jmax, kmax, kmax_total,&
              area, rtime, r1, scaley, x, y, z, dx, dy, dz, &
              R_H(1,1,1), Z_H(1,1,1), RHOZ2_SG(1), &
              A0(1), wrk3d)

#ifdef _DEBUG
         CALL IO_WRITE_ASCII_FIELD('Z2sg_H.dat', i1, jmax, i1, RHOZ2_SG(1))
#endif

#undef R_H
#undef Z_H
#undef TMP1_LOC

#define BARRZ(i,j,k)    txc(i,j,k,1)
#define TMP1_LOC(i,j,k) txc(i,j,k,2)
! ----------------------------------------------------------------
!                                  calculating the coefficient
! ----------------------------------------------------------------
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               TMP1_LOC(ij,1,k) = rho(ij,1,k)*z1(ij,1,k)
            ENDDO
         ENDDO
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
              BARRZ(1,1,1), wrk3d)
! txc size is 4
         CALL SGS_ARM_RANS_A2(imax, jmax, kmax, kmax_total, &
              n0, n1,&
              i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
              dx, dy, dz, barvs(1,1,1,1), barvs(1,1,1,3),&
              BARRZ(1,1,1), RHOZ2_SG(1), &
              A0(1), A1(1), A2(1), cf2x, cf2y, cf2z, &
              TMP1_LOC(1,1,1), wrk3d)
         CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), &
              A2(1), carm_zh)
!     a0_int = SIMPSON_NU(jmax,A0(1),y)
!     a1_int = SIMPSON_NU(jmax,A1(1),y)
!     a2_int = SIMPSON_NU(jmax,A2(1),y)
!     CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!     DO j = 1,jmax
!        carm_zh(j) = c0_int
!     ENDDO

#ifdef _DEBUG
         CALL IO_WRITE_ASCII_FIELD('c0Z_H.dat', i1, jmax, i1, carm_zh)
#endif

      ENDIF

#undef RHOZ2_SG
#undef A0
#undef A1
#undef A2

#undef BARRZ
#undef TMP1_LOC

      RETURN
      END
