      SUBROUTINE SGS_DYN_BARVS(n0, n1, rho, barvs, txc, wrk3d, &
           cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, cf2x, cf2y, cf2z)
      
! # barvs(1) = 1/bar1(bar0(rho))          <--- Always.
! # barvs(2) = 1/bar0(bar0(rho))             | Only
! # barvs(3) = 1/bar1(bar0(bar1(bar0(rho)))) | for Hij.

  USE DNS_GLOBAL
  USE LES_GLOBAL

      IMPLICIT NONE

#include "types.h"
#include "les_const.h"
#include "integers.h"

      TINTEGER n0, n1

      TREAL rho(imax,jmax,kmax)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      TREAL cf1x(*), cf1y(*), cf1z(*)
      TREAL cf2x(*), cf2y(*), cf2z(*)

      TREAL barvs(imax,jmax,kmax,*)
      TREAL txc(imax,jmax,kmax)
      TREAL wrk3d(imax,jmax,kmax)

      TINTEGER ij, k

! bar1(bar0(rho))
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n1, cf1x, cf1y, cf1z, rho, txc, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            barvs(ij,1,k,1)=C_1_R/txc(ij,1,k)
         ENDDO
      ENDDO

      IF ( iles_type_tran .NE. LES_TRAN_NONE ) THEN
! bar0(bar0(rho))
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, cf0x, cf0y, cf0z, rho, barvs(1,1,1,2), wrk3d)
! bar1(bar0(bar1(bar0(rho))))
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, txc, barvs(1,1,1,3), wrk3d)
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               barvs(ij,1,k,2) = C_1_R/barvs(ij,1,k,2)
               barvs(ij,1,k,3) = C_1_R/barvs(ij,1,k,3)
            ENDDO
         ENDDO
      ENDIF

      RETURN
      END
