SUBROUTINE SGS_DYN_NORMAL(idir, ssmflg, n0, n1, coefdelta,&
     dx, dy, dz, rho, u, u_sg, sij, barsij, barvs, frc, mij, &
     dilatation, txc, wrk1d, &
     wrk2d, wrk3d, cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, &
     cf2x, cf2y, cf2z, carm_uf, carm_uh)

! ###############################
! # frc1 is the numerator
! # frc2 is the denominator
! # dilatation1 1/3*dil
! # dilatation2 1/3*bardil
! #
! # txc - required size of 2 if ssmflg is 0
! # txc - required size of 3 if ssmflg is 1
! #
! ###############################

#include "types.h"
#include "les_const.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL

  IMPLICIT NONE

#include "integers.h"

  TINTEGER idir, ssmflg, n0, n1
  TREAL coefdelta

  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TREAL rho(imax,jmax,kmax)
  TREAL u(imax,jmax,kmax)
  TREAL u_sg(imax,jmax,kmax)

  TREAL sij(imax,jmax,kmax)
  TREAL barsij(imax,jmax,kmax)
  TREAL barvs(imax,jmax,kmax,*)
  TREAL frc(imax,jmax,kmax,2)
  TREAL mij(imax,jmax,kmax)
  TREAL dilatation(imax,jmax,kmax,2)
  TREAL txc(imax,jmax,kmax,*)

  TREAL wrk1d(isize_wrk1d,*)
  TREAL wrk2d(*)
  TREAL wrk3d(imax,jmax,kmax)
  TREAL cf0x(*), cf0y(*), cf0z(*)
  TREAL cf1x(*), cf1y(*), cf1z(*)
  TREAL cf2x(*), cf2y(*), cf2z(*)
  TREAL carm_uf(*), carm_uh(*)

  TINTEGER ij, k

#ifdef TRACE_ON
  CALL IO_WRITE_ASCII(tfile, 'ENTERING SGS_DYN_CROSS')
#endif

#define NUMERATOR(i,j,k)   frc(i,j,k,1)
#define DENOMINATOR(i,j,k) frc(i,j,k,2)

! ####################
! # Calculate MiiMii #
! ####################
! -------------------------------------------------------------
!                                                   level 1
! -------------------------------------------------------------
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc(ij,1,k,1) = rho(ij,1,k)*u_sg(ij,1,k)
     ENDDO
  ENDDO
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc(ij,1,k,2) = txc(ij,1,k,2)*barvs(ij,1,k,1)
     ENDDO
  ENDDO
  IF ( idir .EQ. 1 ) THEN
     CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc,&
          dx, txc(1,1,1,2), txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ELSE IF ( idir .EQ. 2 ) THEN
     CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc,&
          dy, txc(1,1,1,2), txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ELSE
     CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc,&
          dz, txc(1,1,1,2), txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ENDIF
  IF ( sgs_devsmag .EQ. 1 ) THEN
     DO k=1,kmax
        DO ij=1,imax*jmax
           mij(ij,1,k) = (txc(ij,1,k,1)-dilatation(ij,1,k,2))*&
                barsij(ij,1,k)*coefdelta
        ENDDO
     ENDDO
  ELSE
     DO k=1,kmax
        DO ij=1,imax*jmax
           mij(ij,1,k) = txc(ij,1,k,1)*barsij(ij,1,k)*coefdelta
        ENDDO
     ENDDO
  ENDIF

! -------------------------------------------------------------
!                                                   level 0
! -------------------------------------------------------------
  IF ( idir .EQ. 1 ) THEN
     CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc,&
          dx, u_sg, txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ELSE IF ( idir .EQ. 2 ) THEN
     CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc,&
          dy, u_sg, txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ELSE
     CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc,&
          dz, u_sg, txc(1,1,1,1), i0, i0, wrk1d, wrk2d, wrk3d)
  ENDIF
  IF ( sgs_devsmag .EQ. 1 ) THEN
     DO k=1,kmax
        DO ij=1,imax*jmax
           txc(ij,1,k,1) = (txc(ij,1,k,1)-dilatation(ij,1,k,1))*sij(ij,1,k)
        ENDDO
     ENDDO
  ELSE
     DO k=1,kmax
        DO ij=1,imax*jmax
           txc(ij,1,k,1) = txc(ij,1,k,1)*sij(ij,1,k)
        ENDDO
     ENDDO
  ENDIF
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
  DO k=1,kmax
     DO ij=1,imax*jmax
        mij(ij,1,k) = txc(ij,1,k,2) - mij(ij,1,k)
        DENOMINATOR(ij,1,k) = DENOMINATOR(ij,1,k) + mij(ij,1,k)*mij(ij,1,k)
     ENDDO
  ENDDO

! ####################     
! # Calculate LiiMii #
! ####################
! -------------------------------------------------------------
!                                                   level 0
! -------------------------------------------------------------
  DO k=1,kmax
     DO ij=1,imax*jmax
        txc(ij,1,k,1) = u(ij,1,k)*u(ij,1,k)*rho(ij,1,k)
     ENDDO
  ENDDO
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
  DO k=1,kmax
     DO ij=1,imax*jmax
        NUMERATOR(ij,1,k) = NUMERATOR(ij,1,k) + mij(ij,1,k)*txc(ij,1,k,2)
     ENDDO
  ENDDO

! -------------------------------------------------------------
!                                                   level 1
! -------------------------------------------------------------
  DO k=1,kmax
     DO ij=1,imax*jmax
        txc(ij,1,k,1) = u(ij,1,k)*rho(ij,1,k)
     ENDDO
  ENDDO
  CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
  DO k=1,kmax
     DO ij=1,imax*jmax
        NUMERATOR(ij,1,k) = NUMERATOR(ij,1,k) - &
             mij(ij,1,k)*txc(ij,1,k,2)*txc(ij,1,k,2)*barvs(ij,1,k,1)
     ENDDO
  ENDDO

#undef NUMERATOR
#undef DENOMINATOR

! ####################
! # Calculate HiiMii #
! ####################
  IF ( ssmflg .EQ. 1 ) THEN
     CALL SGS_DYN_HIJ(i1, n0, n1, dx, dy, dz,&
          rho, u, u, barvs, frc, mij, txc, &
          wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, &
          cf2x, cf2y, cf2z, carm_uf, carm_uh, carm_uf, carm_uh)
  ENDIF

#ifdef TRACE_ON
  CALL IO_WRITE_ASCII(tfile, 'LEAVING SGS_DYN_NORMAL')
#endif

  RETURN
END SUBROUTINE SGS_DYN_NORMAL

