      SUBROUTINE SGS_RECTN_PDIL(n0, statflg, dx, dy, dz, &
           rho, u, v, w, p,&
           h4, mean1d_les, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6,&
           tmp7, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z)

! #######################
! # tmp0 is dil( u )
! # tmp1 is dil( baru )
! #
! # tmp size is 8
! #######################

#include "types.h"
#include "dns_const.h"
#include "les_avgij_map.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL

      IMPLICIT NONE

      TINTEGER n0, statflg

      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)

      TREAL rho(imax, jmax, kmax)
      TREAL u(imax, jmax, kmax)
      TREAL v(imax, jmax, kmax)
      TREAL w(imax, jmax, kmax)
      TREAL p(imax, jmax, kmax)

      TREAL h4(imax, jmax, kmax)

      TREAL mean1d_les(nstatavg,jmax,*)

      TREAL tmp0(imax, jmax, kmax)
      TREAL tmp1(imax, jmax, kmax)
      TREAL tmp2(imax, jmax, kmax)
      TREAL tmp3(imax, jmax, kmax)
      TREAL tmp4(imax, jmax, kmax)
      TREAL tmp5(imax, jmax, kmax)
      TREAL tmp6(imax, jmax, kmax)
      TREAL tmp7(imax, jmax, kmax)
      
      TREAL wrk1d(isize_wrk1d,*)
      TREAL wrk2d(*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      
      TINTEGER ij, i, j, k, isgs_offset
      TINTEGER i0, i2, i3, i5, i6, i7

      i0 = 0
      i2 = 2
      i3 = 3
      i5 = 5
      i6 = 6
      i7 = 7

      IF ( imode_sim .EQ. DNS_MODE_SPATIAL ) THEN
         isgs_offset = 10
      ELSE
         isgs_offset = 1
      ENDIF

#ifdef TRACE_ON
      CALL IO_WRITE_ASCII(tfile, 'ENTERING SGS_RECTN_PDIL' )
#endif

! #################################
! #      pressure equation        #
! #################################
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp5(ij,1,k) = p(ij,1,k)*tmp0(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, tmp5, tmp4, wrk3d)
      DO k = 1,kmax
         DO j = 1,jmax
            DO i = isgs_offset,imax
               h4(i,j,k) = h4(i,j,k) - sgs_pdil*tmp4(i,j,k)
            ENDDO
         ENDDO
      ENDDO
! Statistics
!  IF ( statflg .EQ. 1 ) THEN
!     CALL LES_SAVE_AVGPIJ(i8, dx, dy, dz, tmp4, 
! $        mean1d_les, wrk1d, wrk2d, wrk3d)
!  ENDIF
      
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, p, tmp4, wrk3d)
      DO k = 1,kmax
         DO j = 1,jmax
            DO i = isgs_offset,imax
               h4(i,j,k) = h4(i,j,k) + sgs_pdil*tmp4(i,j,k)*tmp1(i,j,k)
            ENDDO
         ENDDO
      ENDDO
! Statistics
!  IF ( statflg .EQ. 1 ) THEN
!     CALL LES_SAVE_AVGPIJ(i9, dx, dy, dz, tmp4, 
! $        mean1d_les, wrk1d, wrk2d, wrk3d)
!  ENDIF

#ifdef TRACE_ON
      CALL IO_WRITE_ASCII(tfile, 'LEAVING SGS_RECTN_PDIL' )
#endif

      RETURN
      END
