SUBROUTINE COHET_SPA(nvar, ntimes,jmax,kmax,kmax_total, &
     nstatlin, statlin_i, statlin_j, t_dat, l_dat, spct, wrk, wrk1d, connect)
  
#include "types.h"

#ifdef PARALLEL
  USE DNS_MPI
#endif

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif

  TINTEGER nvar, ntimes, jmax, kmax, kmax_total, nstatlin

  TREAL t_dat(2,ntimes)
  TREAL l_dat(ntimes,nstatlin,nvar,kmax)

  TINTEGER statlin_i(nstatlin), statlin_j(nstatlin)

  TREAL wrk(2*ntimes+15)
  TREAL spct(ntimes/2,2*nvar,nstatlin)
  TREAL wrk1d(ntimes,5)
  TINTEGER connect(nstatlin,2)

  TINTEGER m, n, i, j, k, ivar, it, ncohepnt
  TREAL delta_t, freq
! TREAL sum
  CHARACTER*32 filename

#ifdef PARALLEL
  INTEGER len
!  TREAL sum2
#endif

! ################
! # Initializing #
! ################

! Looking for the points in pairs and change format of istatlin

  ncohepnt = 0
  DO n = 1,nstatlin-1
     DO k = n+1,nstatlin
        IF ( statlin_i(k) .EQ. statlin_i(n) ) THEN
           ncohepnt = ncohepnt + 1
           connect(ncohepnt,1) = n
           connect(ncohepnt,2) = k
        ENDIF
     ENDDO
  ENDDO

  CALL RFFTI ( ntimes, wrk )

  DO it = 1,ntimes/2*2*nvar*ncohepnt
     spct(it,1,1) = C_0_R
  ENDDO

  DO it = 1,ntimes
     wrk1d(it,1) = t_dat(2,it)
  ENDDO

! ###################
! # Remove the mean #
! ###################
!
!  DO i = 1,nvar
!     DO n = 1,nstatlin
!        
!        sum = C_0_R
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              sum = sum + l_dat(it,n,i,k)
!           ENDDO
!        ENDDO
!        sum = sum/M_REAL(ntimes)
!#ifdef PARALLEL
!        sum2 = sum/M_REAL(kmax_total)
!        CALL MPI_ALLREDUCE(sum2, sum, 1, MPI_REAL8, MPI_SUM, 
! $           MPI_COMM_WORLD, ims_err)
!#else 
!        sum = sum/M_REAL(kmax_total)
!#endif
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              l_dat(it,n,i,k) = l_dat(it,n,i,k) - sum
!           ENDDO
!        ENDDO
!
!     ENDDO
!  ENDDO

! #########################
! # Obtaining the spectra #
! #########################

  DO k = 1,kmax
     DO ivar = 1, 2
        DO m = 1,ncohepnt
           n = connect(m,1)
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,2) )
           n = connect(m,2)
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,ivar,m) = spct(it,ivar,m) + &
                   SQRT(wrk1d(it,2)*wrk1d(it,4))
              spct(it,6+ivar,m) = spct(it,6+ivar,m) + &
                   wrk1d(ntimes/2+it,2)-wrk1d(ntimes/2+it,4)
           ENDDO
        ENDDO
     ENDDO
  ENDDO

  IF ( kmax_total .GT. 1) THEN
     DO k = 1,kmax
        DO m = 1,ncohepnt
           n = connect(m,1)
           CALL MK_CST_DT(ntimes, l_dat(1,n,3,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,2) )
           n = connect(m,2)
           CALL MK_CST_DT(ntimes, l_dat(1,n,3,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,3,m) = spct(it,3,m) + &
                   SQRT(wrk1d(it,2)*wrk1d(it,4))
              spct(it,6+3,m) = spct(it,6+3,m) + &
                   wrk1d(ntimes/2+it,2)-wrk1d(ntimes/2+it,4)
           ENDDO
        ENDDO
     ENDDO
  ENDIF

  DO k = 1,kmax
     DO ivar = 4, nvar
        DO m = 1,ncohepnt
           n = connect(m,1)
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,2) )
           n = connect(m,2)
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_PH_SPA ( ntimes, wrk1d(1,3), wrk, wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,ivar,m) = spct(it,ivar,m) + &
                   SQRT(wrk1d(it,2)*wrk1d(it,4))
              spct(it,6+ivar,m) = spct(it,6+ivar,m) + &
                   wrk1d(ntimes/2+it,2)-wrk1d(ntimes/2+it,4)
           ENDDO
        ENDDO
     ENDDO
  ENDDO

! Average in k

#ifdef PARALLEL
  len = ntimes/2*2*nvar*ncohepnt
  CALL MPI_ALLREDUCE(spct, l_dat, len, MPI_REAL8, MPI_SUM, &
       MPI_COMM_WORLD, ims_err)
  DO it = 1,ntimes/2*2*nvar*ncohepnt
     spct(it,1,1) = l_dat(it,1,1,1)
  ENDDO
#endif

  DO it = 1,ntimes/2*2*nvar*ncohepnt
     spct(it,1,1) = spct(it,1,1)/M_REAL(kmax_total)
  ENDDO
  DO m = 1,ncohepnt
     DO it = 1,ntimes/2*nvar
        spct(it,1,m) = spct(it,1,m)/M_REAL(ntimes)
     ENDDO
  ENDDO

! ################################
! # Normalized so that N*Rij = sum_1^N Eij,
! # where Eij is the energy itself times N.
! # For DFT Parseval`s equality is Rij=sum_1^N Eij,
! # if Eij were the energy itself. 
! # This is done to collapse all the curves for
! # different number of points.
! ##########################################

! ###############
! # Tkstat file #
! ###############

#ifdef PARALLEL
  IF ( ims_pro .EQ. 0 ) THEN
#endif

     filename = 'tch                                     '
     it = INT(t_dat(1,ntimes))
     CALL CONCATI(filename, it)

     OPEN(unit=23,file=filename)
     WRITE(23,*) 'RTIME = ', t_dat(2,ntimes)
     WRITE(23,*) 'GROUP 1 Coherence_Spc Cohu(ft) Cohv(ft) ',&
          'Cohw(ft) Cohp(ft) Cohr(ft) Cohs(ft) '
     WRITE(23,*) 'GROUP 2 Phase_Spc Phu(ft) Phv(ft) Phw(ft) Php(ft) ', &
          'Phr(ft) Phs(ft)'
     WRITE(23,*) 'I J ft Cohu(ft) Cohv(ft) Cohw(ft) Cohp(ft) ',&
          'Cohr(ft) Cohs(ft) Phu(ft) Phv(ft) Phw(ft) Php(ft) ',&
          'Phr(ft) Phs(ft)'

     DO m = 1,ncohepnt
        i = statlin_i(connect(m,1))
        j = jmax/2
        DO it = 2, ntimes/2
           freq = M_REAL(it-1)/(t_dat(2,ntimes)-t_dat(2,1))  
           WRITE(23,1020) i, j, freq, spct(it,1,m), spct(it,2,m), &
                spct(it,3,m), spct(it,4,m), spct(it,5,m),spct(it,6,m),&
                spct(it,7,m), spct(it,8,m), spct(it,9,m),spct(it,10,m),&
                spct(it,11,m), spct(it,12,m)
        ENDDO
     ENDDO

     CLOSE(23)

#ifdef PARALLEL
  ENDIF
#endif

  RETURN

1020 FORMAT(I3,1X,I3,14(1X,E12.5E3))

END SUBROUTINE COHET_SPA


