      SUBROUTINE KZ1D_PH_SPA ( nmax, udt, wrk, usp )

      IMPLICIT NONE

#include "types.h"

      TINTEGER nmax
      TREAL udt(nmax)
      TREAL wrk(2*nmax+15)
      TREAL usp(nmax)

      TINTEGER n, nn

! ###################    
! # Perform 1-D FFT #
! ###################    

      CALL RFFTF ( nmax, udt, wrk )

! ############################################
! # Obtain DFT                               #
! # We should divide by the number of points #
! # but it is done later                     #
! ############################################

! ###################
! # Obtain spectrum #
! ###################
        
      usp(1) = udt(1)**2/C_2_R
         
      DO n = 2, nmax/2
         nn = 2*n-1
         usp(n) = udt(nn-1)*udt(nn-1) + udt(nn)*udt(nn)
      ENDDO
         
! ####################
! # Obtain the phase #
! ####################

      usp(nmax/2+1) = C_0_R
         
      DO n = 2, nmax/2
         nn = 2*n-1
         usp(nmax/2+n) = ACOS(udt(nn-1)/SQRT(usp(n)))
         IF (udt(nn).LT.C_0_R) usp(nmax/2+n) =-usp(nmax/2+n) 
      ENDDO
         
      RETURN
      END

