SUBROUTINE KZ_SPA ( nvar, ntimes, kmax, nstatlin,&
     delta_z, statlin_i, statlin_j, t_dat, l_dat, spct, wrk, wrk1d, tmp )

! #
! # IT IS NOT PARALLELIZED YET
! # FFTW NOT CHECK YET

  IMPLICIT NONE

#include "types.h"
#ifdef USE_FFTW
#include "fftw3.f"
#endif

  TINTEGER nvar, ntimes, kmax, nstatlin

  TREAL delta_z 

  TREAL t_dat(2,ntimes)
  TREAL l_dat(ntimes,nstatlin,nvar,kmax)

  TINTEGER statlin_i(nstatlin), statlin_j(nstatlin)

  TREAL spct(kmax/2,nvar,nstatlin)
  TREAL wrk1d(kmax,2)
  TREAL tmp(kmax/2,nvar)
  TREAL wrk(2*kmax+15)

  TINTEGER i,j,k,n,it,itime,ivar
!  TREAL sum
  TREAL freq
  CHARACTER*32 filename
  INTEGER(8) fft_plan

  IF ( kmax .EQ. 1 ) RETURN

! ###################
! # Remove the mean #
! ###################
!
!  DO i = 1,nvar
!     DO n = 1,nstatlin
!
!        sum = C_0_R
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              sum = sum + l_dat(it,n,i,k)
!           ENDDO
!        ENDDO
!        sum = sum/M_REAL(kmax*ntimes)
!
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              l_dat(it,n,i,k) = l_dat(it,n,i,k) - sum
!           ENDDO
!        ENDDO
!        
!     ENDDO
!  ENDDO

! ######################
! # Calculate spectrum #
! ######################

  DO k = 1,kmax/2*nvar*nstatlin
     spct(k,1,1) = C_0_R
  ENDDO

! -----------------------------------------------------------------------
! FFTW
! -----------------------------------------------------------------------
#ifdef USE_FFTW
  CALL dfftw_plan_dft_r2c_1d(fft_plan, kmax, wrk, wrk, FFTW_ESTIMATE)
! -----------------------------------------------------------------------
! old fft
! -----------------------------------------------------------------------
#else
  CALL RFFTI ( kmax, wrk )
#endif

  DO it = 1,ntimes
     DO n = 1,nstatlin     
        DO ivar = 1,nvar
           DO k = 1,kmax
              wrk1d(k,1) = l_dat(it,n,ivar,k)
           ENDDO
           CALL KZ1D_SPA ( kmax, wrk1d(1,1), fft_plan, wrk, tmp(1,ivar), wrk1d(1,2) )
        ENDDO
        DO k = 1,kmax/2*nvar
           spct(k,1,n) = spct(k,1,n) + tmp(k,1) 
        ENDDO
     ENDDO
  ENDDO

! ############################
! # Normalizing like in kt_spa
! ############################

  DO k = 1,kmax/2*nvar*nstatlin
     spct(k,1,1) = spct(k,1,1)/M_REAL(ntimes*kmax) 
  ENDDO

! ###############
! # Tkstat file #
! ###############

  filename = 'zsp                                     '
  itime = INT(t_dat(1,ntimes))
  CALL CONCATI(filename, itime)

  OPEN(unit=23,file=filename)
  WRITE(23, *) 'RTIME = ', t_dat(2,ntimes)
  WRITE(23, *) 'I J fz Eu(fz) Ev(fz) Ew(fz) E(fz) P(fz) R(fz) S(fz)'

  DO n = 1,nstatlin
     i = statlin_i(n)
     j = statlin_j(n)
     DO k = 2, kmax/2
        freq = M_REAL(k-1)/(delta_z*kmax)  
        WRITE(23,1020) i, j, freq, spct(k,1,n), spct(k,2,n), &
             spct(k,3,n), &
             C_05_R*(spct(k,1,n)+spct(k,2,n)+spct(k,3,n)),&
             spct(k,4,n), spct(k,5,n), spct(k,6,n)
     ENDDO
  ENDDO

  CLOSE(23)

! ###################################################################
#ifdef USE_FFTW
  CALL dfftw_destroy_plan(fft_plan)
#endif

  RETURN

1020 FORMAT(I3,1X,I3,8(1X,E12.5E3))

END SUBROUTINE KZ_SPA

