














		   



			   
               	           






!########################################################################
!# Tool/Library
!#
!########################################################################
!# HISTORY
!#
!# 2007/11/08 - J.P. Mellado
!#              Created
!#
!########################################################################
!# DESCRIPTION
!#
!# Calculating the equilibrium T and q_l for given enthalpy and pressure,
!# iterative based on (rho,e,q_i)
!#
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
SUBROUTINE THERMO_AIRWATER_PH2(nx, ny, nz, z1, p, h, T)

  USE THERMO_GLOBAL, ONLY : GRATIO, MRATIO, THERMO_AI

  IMPLICIT NONE

INTEGER(4) i0, i1, i2, i3, i4, i5, i6, i7 ,i8, i9
  PARAMETER(i0=0)
  PARAMETER(i1=1)
  PARAMETER(i2=2)
  PARAMETER(i3=3)
  PARAMETER(i4=4)
  PARAMETER(i5=5)
  PARAMETER(i6=6)
  PARAMETER(i7=7)
  PARAMETER(i8=8)
  PARAMETER(i9=9)
  INTEGER(4) i10, i11, i12, i13, i14, i15, i16, i17 ,i18, i19
  PARAMETER(i10=10)
  PARAMETER(i11=11)
  PARAMETER(i12=12)
  PARAMETER(i13=13)
  PARAMETER(i14=14)
  PARAMETER(i15=15)
  PARAMETER(i16=16)
  PARAMETER(i17=17)
  PARAMETER(i18=18)
  PARAMETER(i19=19)
  INTEGER(4) i20, i21, i22, i23, i24, i25, i26, i27 ,i28, i29
  PARAMETER(i20=20)
  PARAMETER(i21=21)
  PARAMETER(i22=22)
  PARAMETER(i23=23)
  PARAMETER(i24=24)
  PARAMETER(i25=25)
  PARAMETER(i26=26)
  PARAMETER(i27=27)
  PARAMETER(i28=28)
  PARAMETER(i29=29)
  INTEGER(4) i30, i31, i32, i33, i34, i35, i36, i37 ,i38, i39
  PARAMETER(i30=30)
  PARAMETER(i31=31)
  PARAMETER(i32=32)
  PARAMETER(i33=33)
  PARAMETER(i34=34)
  PARAMETER(i35=35)
  PARAMETER(i36=36)
  PARAMETER(i37=37)
  PARAMETER(i38=38)
  PARAMETER(i39=39)
  INTEGER(4) i50, i51, i52, i53, i54, i55, i56, i57 ,i58, i59
  PARAMETER(i50=50)
  PARAMETER(i51=51)
  PARAMETER(i52=52)
  PARAMETER(i53=53)
  PARAMETER(i54=54)
  PARAMETER(i55=55)
  PARAMETER(i56=56)
  PARAMETER(i57=57)
  PARAMETER(i58=58)
  PARAMETER(i59=59)
  INTEGER(4) i150
  PARAMETER(i150=150)

  INTEGER(4) nx, ny, nz
  REAL(8) z1(nx*ny*nz,*), T(*), h(*), p(*)

! -------------------------------------------------------------------
  INTEGER(4) ij, iter, niter
  REAL(8) r_loc, e_loc, t_loc, z1_loc(2), dummy, prefactor

! ###################################################################
  niter = 5
  prefactor = GRATIO*MRATIO ! = (gama0-1.0d0)*mach*mach

  DO ij = 1,nx*ny*nz
! -------------------------------------------------------------------
! initialize, q_l=0
! -------------------------------------------------------------------
     z1_loc(1) = z1(ij,1)
     z1_loc(2) = 0.0d0
     t_loc = (h(ij)-THERMO_AI(6,1,2)-z1(ij,1)*(THERMO_AI(6,1,1)-THERMO_AI(6,1,2)))/&
          (THERMO_AI(1,1,2)+z1(ij,1)*(THERMO_AI(1,1,1)-THERMO_AI(1,1,2)))

! -------------------------------------------------------------------
! iteration
! -------------------------------------------------------------------
     DO iter = 1,niter
! calculate density from temperature/composition
        CALL THERMO_THERMAL_DENSITY(i1, i1, i1, z1_loc, p(ij), t_loc, r_loc)

! calculate energy
        e_loc = h(ij) - prefactor*p(ij)/r_loc

! solve equilibrium (rho,e,q_i)
        CALL THERMO_AIRWATER_RE(i1, i1, i1, z1_loc, e_loc, r_loc, t_loc, dummy)

     ENDDO
     z1(ij,2) = z1_loc(2)
     T(ij)    = t_loc

  ENDDO

  RETURN
END SUBROUTINE THERMO_AIRWATER_PH2
