














		   



			   
               	           






!########################################################################
!# Tool/Library
!#
!########################################################################
!# HISTORY
!#
!# 2007/11/08 - J.P. Mellado
!#              Created
!#
!########################################################################
!# DESCRIPTION
!#
!# Calculating the equilibrium T and for given enthalpy and pressure, and ql
!# It is not iterative since we do not ned the equilibrium state
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
SUBROUTINE THERMO_SUPSAT_PH(nx, ny, nz, Temperature, s_in, qsat_vapor, p, h) 

  USE THERMO_GLOBAL, ONLY : THERMO_AI, THERMO_PSAT, NPSAT, WGHT_INV, dsmooth

  IMPLICIT NONE

INTEGER(4) i0, i1, i2, i3, i4, i5, i6, i7 ,i8, i9
  PARAMETER(i0=0)
  PARAMETER(i1=1)
  PARAMETER(i2=2)
  PARAMETER(i3=3)
  PARAMETER(i4=4)
  PARAMETER(i5=5)
  PARAMETER(i6=6)
  PARAMETER(i7=7)
  PARAMETER(i8=8)
  PARAMETER(i9=9)
  INTEGER(4) i10, i11, i12, i13, i14, i15, i16, i17 ,i18, i19
  PARAMETER(i10=10)
  PARAMETER(i11=11)
  PARAMETER(i12=12)
  PARAMETER(i13=13)
  PARAMETER(i14=14)
  PARAMETER(i15=15)
  PARAMETER(i16=16)
  PARAMETER(i17=17)
  PARAMETER(i18=18)
  PARAMETER(i19=19)
  INTEGER(4) i20, i21, i22, i23, i24, i25, i26, i27 ,i28, i29
  PARAMETER(i20=20)
  PARAMETER(i21=21)
  PARAMETER(i22=22)
  PARAMETER(i23=23)
  PARAMETER(i24=24)
  PARAMETER(i25=25)
  PARAMETER(i26=26)
  PARAMETER(i27=27)
  PARAMETER(i28=28)
  PARAMETER(i29=29)
  INTEGER(4) i30, i31, i32, i33, i34, i35, i36, i37 ,i38, i39
  PARAMETER(i30=30)
  PARAMETER(i31=31)
  PARAMETER(i32=32)
  PARAMETER(i33=33)
  PARAMETER(i34=34)
  PARAMETER(i35=35)
  PARAMETER(i36=36)
  PARAMETER(i37=37)
  PARAMETER(i38=38)
  PARAMETER(i39=39)
  INTEGER(4) i50, i51, i52, i53, i54, i55, i56, i57 ,i58, i59
  PARAMETER(i50=50)
  PARAMETER(i51=51)
  PARAMETER(i52=52)
  PARAMETER(i53=53)
  PARAMETER(i54=54)
  PARAMETER(i55=55)
  PARAMETER(i56=56)
  PARAMETER(i57=57)
  PARAMETER(i58=58)
  PARAMETER(i59=59)
  INTEGER(4) i150
  PARAMETER(i150=150)

  INTEGER(4) nx, ny, nz
  REAL(8), DIMENSION(nx*ny*nz,2), INTENT(IN)  :: s_in !Array with total water and liquid water
  REAL(8), INTENT(IN)                         ::  p !Alberto pressure whcis is now is now an scalar  
  REAL(8), DIMENSION(nx*ny*nz), INTENT(IN)    :: h  !array with the entahlpy
  REAL(8), DIMENSION(nx*ny*nz), INTENT(OUT)   :: qsat_vapor, Temperature  !Exit array with the saturation pressure vapor and the temperature
  
  
  REAL(8) q_latent, cp_d, cp_v, cl, psat, psat_coeff(20),  rd_ov_rv !Auxialliary variables to spped up
! -------------------------------------------------------------------
  INTEGER(4) ij, ipsat, dum_npsat
  REAL(8) t_loc  



!$omp parallel default( none ) private( ij, t_loc, psat, ipsat, cp_v, cp_d, cl, rd_ov_rv, q_latent, psat_coeff,dum_npsat) shared( Temperature, qsat_vapor,s_in, h, nx, ny, nz, THERMO_AI, WGHT_INV, NPSAT, THERMO_PSAT, p)
  

! ###################################################################

  
  q_latent = -THERMO_AI(6,1,3)
  cp_d = THERMO_AI(1,1,2)
  cp_v = THERMO_AI(1,1,1)
  cl = THERMO_AI(1,1,3)
  rd_ov_rv = 1.0d0/WGHT_INV(1)
  dum_npsat = NPSAT
  DO ipsat = dum_npsat,1,-1
     psat_coeff(ipsat) = THERMO_PSAT(ipsat)/p  !Assuming pressure defined the code and in the definiction of PSAT in HPa 
  ENDDO
  

!$omp do
  DO ij = 1,nx*ny*nz
     t_loc = (h(ij) + s_in(ij,2)*q_latent )/( (1-s_in(ij,1))*cp_d + (s_in(ij,1)-s_in(ij,2))*cp_v + s_in(ij,2)* cl )  !Temperature                           
     psat = 0.0d0                             
     DO ipsat = dum_npsat,1,-1 !Saturation pressure
	psat = psat*t_loc + psat_coeff(ipsat) !psat is scaled witrh p
     ENDDO     
     qsat_vapor(ij) = (1.0d0-s_in(ij,1))*rd_ov_rv/(1.0d0/psat-1.0d0)
     Temperature(ij) = t_loc

   ENDDO
!$omp end do
!$omp end parallel

  RETURN
END SUBROUTINE THERMO_SUPSAT_PH
