      SUBROUTINE FLAME_INIT(nmax, Z, Y, T, rho)

! ######################################################################
! # Same as BRKSHTE in library FLOW modify to save the mass fractions
! #
! ######################################################################

      IMPLICIT NONE

#include "types.h"
#include "common.h"
#include "dns_const.h"

      TINTEGER nmax
      TREAL Z(nmax)
      TREAL Y(nmax,NSP-1), T(nmax), rho(nmax)

      TREAL HE, eps, WOX
      TINTEGER is, im, icp, n

      eps = C_1_R

      WOX = 1/(YOX/WGHT(2)+(1-YOX)/WGHT(NSP))/WREF
      T(1) = MRATIO*p_init/mean_rho*WOX

! Burke-Schumann profiles
      DO n = 1,nmax

      IF ( imech_type .EQ. CHEM_TYPE_BILGER1997 ) THEN

! Initialize the intermediate species
         YMASS(5) = eps*(Z(n)*(C_1_R-Z(n)))**C_2_R
         YMASSP(5) = C_0_R
         Y(n,5)   = YMASS(5)

! argon
         YMASS(6) = 0.51*(1-Z(n))
         YMASSP(6) = C_0_R
         Y(n,6 )  = YMASS(6)
      ENDIF

! Mass fractions
#define MACRO_ZINPUT Z(n)
#include "dns_chem_mass.h"
         DO is = 1,NSP-1
            Y(n,is) = YMASS(is)
         ENDDO

! Temperature
         HE = (HOX + (HFUEL-HOX)*Z(n))
#define MACRO_HINPUT HE
#define MACRO_TINPUT T(n)
#include "dns_chem_inv.h"

! Density
         rho(n) = MRATIO*p_init*WMEAN/T(n)
               
      ENDDO

      RETURN
      END
