      SUBROUTINE DEC_CROSS(mmax, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc, n0,&
           cf0x, cf0y, cf0z, u, v, txc1, txc2, txc3, txc4, wrk3d)

! input ...: original field u
!            original field v
! output ..: txc1, filtered field u
!            txc2, filtered field v
!            txc3, variance field

      IMPLICIT NONE

#include "types.h"
#include "integers.h"

      TINTEGER mmax
      TINTEGER imax, jmax, kmax, kmax_total
      TINTEGER iunifx, iunify, iunifz
      TINTEGER i1bc, j1bc, k1bc
      TINTEGER n0

      TREAL txc1(imax,jmax,kmax)
      TREAL txc2(imax,jmax,kmax)
      TREAL txc3(imax,jmax,kmax)
      TREAL txc4(imax,jmax,kmax)
      TREAL u(imax,jmax,kmax)
      TREAL v(imax,jmax,kmax)

      TREAL wrk3d(imax,jmax,*)
      TREAL cf0x(*), cf0y(*), cf0z(*)

      TINTEGER ij, k

      DO k = 1,kmax
         DO ij = 1,imax*jmax
            txc1(ij,1,k) = u(ij,1,k)*v(ij,1,k)
         ENDDO
      ENDDO
!  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $     n0, cf0x, cf0y, cf0z, txc1, txc3, wrk3d)
      CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, txc1, txc3, txc4, wrk3d)

!  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $     n0, cf0x, cf0y, cf0z, u, txc1, wrk3d)
      CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, u, txc1, txc4, wrk3d)
!  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $     n0, cf0x, cf0y, cf0z, v, txc2, wrk3d)
      CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, v, txc2, txc4, wrk3d)

      DO k = 1,kmax
         DO ij = 1,imax*jmax
            txc3(ij,1,k) = txc3(ij,1,k) - txc1(ij,1,k)*txc2(ij,1,k)
         ENDDO
      ENDDO

      RETURN
      END
