SUBROUTINE WRT_TRC(maxnrest, t_dat, l_dat, ntimeset, timeset, nkplanes, kplanes, wrk1d)

#include "types.h"

  USE DNS_GLOBAL

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif

  TINTEGER maxnrest 
  TINTEGER ntimeset, nkplanes

  TREAL t_dat(2,maxnrest)
  TREAL l_dat(maxnrest,nstatlin,inb_vars,kmax)

  TINTEGER timeset(ntimeset), kplanes(nkplanes)
  TREAL wrk1d(inb_vars,kmax_total)

  TINTEGER i, j, k, it, n 
  TINTEGER ivar
  CHARACTER*32 fname, name
  CHARACTER*64 line1
  CHARACTER*256 line2

! ##################
! # Initialization #
! ##################

#ifdef PARALLEL
  IF ( ims_pro .EQ. 0 ) THEN
#endif

! TkStat

     WRITE(fname,*) INT(timeset(ntimeset)); fname='trc'//TRIM(ADJUSTL(fname))

     OPEN(unit=23,file=fname)
     WRITE(23, *) 'RTIME = ', t_dat(2,maxnrest)

     line2='I J time'
     DO k = 1,nkplanes
        WRITE(name,*) kplanes(k)
        line1 =                         'u('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//') v('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//') w('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//') e('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//') r('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//') z('//TRIM(ADJUSTL(name))
        line1 = TRIM(ADJUSTL(line1))//')'

        WRITE(name,*) kplanes(k); name='GROUP = Plane_'//TRIM(ADJUSTL(name))
        WRITE(23,'(A)') TRIM(ADJUSTL(name))//' '//TRIM(ADJUST(line1))
        
        line2 = TRIM(ADJUSTL(line2))//' '//TRIM(ADJUSTL(line1))
     ENDDO

     WRITE(23,'(A)') TRIM(ADJUSTL(line2))

     DO n = 1,nstatlin
        i = statlin_i(n)
        j = statlin_j(n)
        DO it = 1,maxnrest
           DO k = 1,nkplanes
              DO ivar = 1,inb_vars
                 wrk1d(ivar,k) = l_dat(it,n,ivar,kplanes(k))
              ENDDO
           ENDDO
           WRITE(23,1020) i, j, t_dat(2,it), (wrk1d(k,1),k=1,inb_vars*nkplanes)
        ENDDO
     ENDDO

     CLOSE(23)

#ifdef PARALLEL
  ENDIF
#endif

  RETURN

1020 FORMAT(I3,1X,I3,1000(1X,E14.7E3))

END SUBROUTINE WRT_TRC



